{Written by Attila Szomor, his e-mail: aszomor@dravanet.hu}
{$R-,W-,S-,A-}

unit ODBCIntf;

interface

uses
{$IFDEF MSWINDOWS}
  Windows;
{$ENDIF}
{$IFDEF LINUX}
  Types;
{$ENDIF}

const
{$IFDEF MSWINDOWS}
  ODBC_DLL = 'ODBC32.DLL';
{$ENDIF}
{$IFDEF LINUX}
  ODBC_DLL = 'libodbc.so';
{$ENDIF}

type
  tagDATE_STRUCT = packed Record
    year  : smallInt;
    month : word;
    day   : word;
  End;

  tagTIME_STRUCT = packed Record
    hour   : word;
    minute : word;
    second : word;
  End;

  tagTIMESTAMP_STRUCT = packed Record
    year     : smallInt;
    month    : word;
    day      : word;
    hour     : word;
    minute   : word;
    second   : word;
    fraction : longInt;
  End;

  lpVoid = Pointer;

const
  {  }
  {  Defines for functions }
  {  }
  SQL_API_SQLALLOCCONNECT         = smallInt(     1);  {Core Functions}
  SQL_API_SQLALLOCENV             = smallInt(     2);
  SQL_API_SQLALLOCSTMT            = smallInt(     3);
  SQL_API_SQLBINDCOL              = smallInt(     4);
  SQL_API_SQLCANCEL               = smallInt(     5);
  SQL_API_SQLCOLATTRIBUTES        = smallInt(     6);
  SQL_API_SQLCONNECT              = smallInt(     7);
  SQL_API_SQLDESCRIBECOL          = smallInt(     8);
  SQL_API_SQLDISCONNECT           = smallInt(     9);
  SQL_API_SQLERROR                = smallInt(    10);
  SQL_API_SQLEXECDIRECT           = smallInt(    11);
  SQL_API_SQLEXECUTE              = smallInt(    12);
  SQL_API_SQLFETCH                = smallInt(    13);
  SQL_API_SQLFREECONNECT          = smallInt(    14);
  SQL_API_SQLFREEENV              = smallInt(    15);
  SQL_API_SQLFREESTMT             = smallInt(    16);
  SQL_API_SQLGETCURSORNAME        = smallInt(    17);
  SQL_API_SQLNUMRESULTCOLS        = smallInt(    18);
  SQL_API_SQLPREPARE              = smallInt(    19);
  SQL_API_SQLROWCOUNT             = smallInt(    20);
  SQL_API_SQLSETCURSORNAME        = smallInt(    21);
  SQL_API_SQLSETPARAM             = smallInt(    22);
  SQL_API_SQLTRANSACT             = smallInt(    23);
  SQL_API_SQLCOLUMNS              = smallInt(    40);  {Level 1 Functions}
  SQL_API_SQLDRIVERCONNECT        = smallInt(    41);
  SQL_API_SQLGETCONNECTOPTION     = smallInt(    42);
  SQL_API_SQLGETDATA              = smallInt(    43);
  SQL_API_SQLGETFUNCTIONS         = smallInt(    44);
  SQL_API_SQLGETINFO              = smallInt(    45);
  SQL_API_SQLGETSTMTOPTION        = smallInt(    46);
  SQL_API_SQLGETTYPEINFO          = smallInt(    47);
  SQL_API_SQLPARAMDATA            = smallInt(    48);
  SQL_API_SQLPUTDATA              = smallInt(    49);
  SQL_API_SQLSETCONNECTOPTION     = smallInt(    50);
  SQL_API_SQLSETSTMTOPTION        = smallInt(    51);
  SQL_API_SQLSPECIALCOLUMNS       = smallInt(    52);
  SQL_API_SQLSTATISTICS           = smallInt(    53);
  SQL_API_SQLTABLES               = smallInt(    54);
  SQL_API_SQLBROWSECONNECT        = smallInt(    55);  {Level 2 Functions}
  SQL_API_SQLCOLUMNPRIVILEGES     = smallInt(    56);
  SQL_API_SQLDATASOURCES          = smallInt(    57);
  SQL_API_SQLDESCRIBEPARAM        = smallInt(    58);
  SQL_API_SQLEXTENDEDFETCH        = smallInt(    59);
  SQL_API_SQLFOREIGNKEYS          = smallInt(    60);
  SQL_API_SQLMORERESULTS          = smallInt(    61);
  SQL_API_SQLNATIVESQL            = smallInt(    62);
  SQL_API_SQLNUMPARAMS            = smallInt(    63);
  SQL_API_SQLPARAMOPTIONS         = smallInt(    64);
  SQL_API_SQLPRIMARYKEYS          = smallInt(    65);
  SQL_API_SQLPROCEDURECOLUMNS     = smallInt(    66);
  SQL_API_SQLPROCEDURES           = smallInt(    67);
  SQL_API_SQLSETPOS               = smallInt(    68);
  SQL_API_SQLSETSCROLLOPTIONS     = smallInt(    69);
  SQL_API_SQLTABLEPRIVILEGES      = smallInt(    70);
  SQL_API_SQLDRIVERS              = smallInt(    71);  {SDK 2.0 Additions}
  SQL_API_SQLBINDPARAMETER        = smallInt(    72);

  SQL_API_ALL_FUNCTIONS           = smallInt(     0);
  SQL_NUM_FUNCTIONS               = smallInt(    23);                   {Core end}
  SQL_EXT_API_START               = smallInt(SQL_API_SQLCOLUMNS);       {Level 1 start}
  SQL_EXT_API_LAST                = smallInt(SQL_API_SQLBINDPARAMETER); {Level 2 end}
  SQL_NUM_EXTENSIONS              = smallInt(SQL_EXT_API_LAST-SQL_EXT_API_START+1);
  SQL_API_LOADBYORDINAL           = smallInt(   199);

  SQL_API_OPENTABLE               = smallInt(    73);  {In few flat table drivers only !!!}
  SQL_API_SQLSETCONNECTATTR       = smallInt(  1016);  {Level 3 Functions}
  SQL_API_SQLSETENVATTR           = smallInt(  1019);
  {  }
  {  Defines for us }
  {  }
  SQL_EXT_API_BEGIN               = smallInt(SQL_API_OPENTABLE);
  SQL_EXT_API_END                 = smallInt(SQL_API_OPENTABLE+2);
  SQL_EXT_API_NUM                 = smallInt(SQL_EXT_API_END-SQL_EXT_API_BEGIN+1);
  {  }
  {  generally useful constants }
  {  }
  SQL_SQLSTATE_SIZE               = smallInt(     5);  {size of SQLSTATE             }
  SQL_MAX_MESSAGE_LENGTH          = smallInt(   512);  {message buffer size          }
  SQL_MAX_DSN_LENGTH              = smallInt(    32);  {maximum data source name size}
  SQL_MAX_OPTION_STRING_LENGTH    = smallInt(   256);
  {  }
  {  ODBC RETCODEs }
  {  }
  SQL_SUCCESS                     = smallInt(     0);
  SQL_SUCCESS_WITH_INFO           = smallInt(     1);
  SQL_NO_DATA_FOUND               = smallInt(   100);
  SQL_ERROR                       = smallInt(    -1);
  SQL_INVALID_HANDLE              = smallInt(    -2);
  {  Additional return codes }
  SQL_STILL_EXECUTING             = smallInt(     2);
  SQL_NEED_DATA                   = smallInt(    99);
  {  }
  {  Standard SQL datatypes, using ANSI type numbering }
  {  }
  SQL_CHAR                        = smallInt(     1);
  SQL_NUMERIC                     = smallInt(     2);
  SQL_DECIMAL                     = smallInt(     3);
  SQL_INTEGER                     = smallInt(     4);
  SQL_SMALLINT                    = smallInt(     5);
  SQL_FLOAT                       = smallInt(     6);
  SQL_REAL                        = smallInt(     7);
  SQL_DOUBLE                      = smallInt(     8);
  SQL_DATE                        = smallInt(     9);
  SQL_TIME                        = smallInt(    10);
  SQL_TIMESTAMP                   = smallInt(    11);
  SQL_VARCHAR                     = smallInt(    12);
  SQL_LONGVARCHAR                 = smallInt(    -1);
  SQL_BINARY                      = smallInt(    -2);
  SQL_VARBINARY                   = smallInt(    -3);
  SQL_LONGVARBINARY               = smallInt(    -4);
  SQL_BIGINT                      = smallInt(    -5);
  SQL_TINYINT                     = smallInt(    -6);
  SQL_BIT                         = smallInt(    -7);
  SQL_SIGNED_OFFSET               = smallInt(   -20);
  SQL_UNSIGNED_OFFSET             = smallInt(   -22);
  SQL_TYPE_DRIVER_START           = smallInt(   -80);
  SQL_ALL_TYPES                   = smallInt(     0);
  SQL_TYPE_MIN                    = smallInt(SQL_BIT);
  SQL_DATE_TIME                   = smallInt(     9);  { LEVEL 3 }
  SQL_TYPE_DATE                   = smallInt(    91);  { LEVEL 3 }
  SQL_TYPE_TIME                   = smallInt(    92);  { LEVEL 3 }
  SQL_TYPE_TIMESTAMP              = smallInt(    93);  { LEVEL 3 }
  {  }
  {  C datatype to SQL datatype mapping   SQL types }
  {  }
  SQL_C_CHAR                      = smallInt(SQL_CHAR     ); {CHAR,VARCHAR,DECIMAL,NUMERIC}
  SQL_C_LONG                      = smallInt(SQL_INTEGER  ); {INTEGER                     }
  SQL_C_SHORT                     = smallInt(SQL_SMALLINT ); {smallInt                    }
  SQL_C_FLOAT                     = smallInt(SQL_REAL     ); {REAL                        }
  SQL_C_DOUBLE                    = smallInt(SQL_DOUBLE   ); {FLOAT, DOUBLE               }
  SQL_C_DATE                      = smallInt(SQL_DATE     );
  SQL_C_TIME                      = smallInt(SQL_TIME     );
  SQL_C_TIMESTAMP                 = smallInt(SQL_TIMESTAMP);
  SQL_C_BINARY                    = smallInt(SQL_BINARY   );
  SQL_C_BIT                       = smallInt(SQL_BIT      );
  SQL_C_TINYINT                   = smallInt(SQL_TINYINT  );
  SQL_C_SLONG                     = smallInt(SQL_C_LONG +SQL_SIGNED_OFFSET  ); {SIGNED smallInt   }
  SQL_C_SSHORT                    = smallInt(SQL_C_SHORT+SQL_SIGNED_OFFSET  ); {SIGNED smallInt  }
  SQL_C_STINYINT                  = smallInt(SQL_TINYINT+SQL_SIGNED_OFFSET  ); {SIGNED TINYINT   }
  SQL_C_ULONG                     = smallInt(SQL_C_LONG +SQL_UNSIGNED_OFFSET); {UNSIGNED smallInt }
  SQL_C_USHORT                    = smallInt(SQL_C_SHORT+SQL_UNSIGNED_OFFSET); {UNSIGNED smallInt}
  SQL_C_UTINYINT                  = smallInt(SQL_TINYINT+SQL_UNSIGNED_OFFSET); {UNSIGNED TINYINT }
  SQL_C_BOOKMARK                  = smallInt(SQL_C_ULONG  );                   {BOOKMARK         }
  SQL_C_DEFAULT                   = smallInt(    99);
  {  }
  {  Options for SQLDriverConnect }
  {  }
  SQL_DRIVER_NOPROMPT             = word(     0);
  SQL_DRIVER_COMPLETE             = word(     1);
  SQL_DRIVER_PROMPT               = word(     2);
  SQL_DRIVER_COMPLETE_REQUIRED    = word(     3);
  {  }
  {  NULL status constants.  These are used in SQLColumns, SQLColAttributes,
     SQLDescribeCol, SQLDescribeParam, and SQLSpecialColumns to describe the
     nullablity of a column in a table. }
  {  }
  SQL_NO_NULLS                    = longInt(      0);
  SQL_NULLABLE                    = longInt(      1);
  SQL_NULLABLE_UNKNOWN            = longInt(      2);
  {  }
  {  Special length values }
  {  }
  SQL_NULL_DATA                   = longInt(     -1);
  SQL_DATA_AT_EXEC                = longInt(     -2);
  SQL_NTS                         = longInt(     -3);
  {  }
  {  SQLFreeStmt defines }
  {  }
  SQL_CLOSE                       = smallInt(     0);
  SQL_DROP                        = smallInt(     1);
  SQL_UNBIND                      = smallInt(     2);
  SQL_RESET_PARAMS                = smallInt(     3);
  {  }
  {  SQLTransact defines }
  {  }
  SQL_COMMIT                      = word(     0);
  SQL_ROLLBACK                    = word(     1);
  {  }
  {  SQLColAttributes defines }
  {  }
  SQL_COLUMN_COUNT                = word(     0);
  SQL_COLUMN_NAME                 = word(     1);
  SQL_COLUMN_TYPE                 = word(     2);
  SQL_COLUMN_LENGTH               = word(     3);
  SQL_COLUMN_PRECISION            = word(     4);
  SQL_COLUMN_SCALE                = word(     5);
  SQL_COLUMN_DISPLAY_SIZE         = word(     6);
  SQL_COLUMN_NULLABLE             = word(     7);
  SQL_COLUMN_UNSIGNED             = word(     8);
  SQL_COLUMN_MONEY                = word(     9);
  SQL_COLUMN_UPDATABLE            = word(    10);
  SQL_COLUMN_AUTO_INCREMENT       = word(    11);
  SQL_COLUMN_CASE_SENSITIVE       = word(    12);
  SQL_COLUMN_SEARCHABLE           = word(    13);
  SQL_COLUMN_TYPE_NAME            = word(    14);
  SQL_COLUMN_TABLE_NAME           = word(    15);
  SQL_COLUMN_OWNER_NAME           = word(    16);
  SQL_COLUMN_QUALIFIER_NAME       = word(    17);
  SQL_COLUMN_LABEL                = word(    18);
  SQL_COLATT_OPT_MIN              = word(SQL_COLUMN_COUNT);
  SQL_COLATT_OPT_MAX              = word(SQL_COLUMN_LABEL);
  SQL_COLUMN_DRIVER_START         = word(  1000);
  {  }
  {  SQLColAttributes subdefines for SQL_COLUMN_UPDATABLE }
  {  }
  SQL_ATTR_READONLY               = word(     0);
  SQL_ATTR_WRITE                  = word(     1);
  SQL_ATTR_READWRITE_UNKNOWN      = word(     2);
  {  }
  {  SQLColAttributes subdefines for SQL_COLUMN_SEARCHABLE }
  {  These are also used by SQLGetInfo                     }
  {  }
  SQL_UNSEARCHABLE                = word(     0);
  SQL_LIKE_ONLY                   = word(     1);
  SQL_ALL_EXCEPT_LIKE             = word(     2);
  SQL_SEARCHABLE                  = word(     3);
  {  }
  {  SQLError defines }
  {  }
  SQL_NULL_HENV                   = lpVoid(   0);
  SQL_NULL_HDBC                   = lpVoid(   0);
  SQL_NULL_HSTMT                  = lpVoid(   0);
  {  }
  {  Special return values for SQLGetData }
  SQL_NO_TOTAL                    = word(    -4);
  {  }
  {  SQLSetParam extensions }
  {  }
  SQL_DEFAULT_PARAM               = word(    -5);
  SQL_IGNORE                      = word(    -6);
  SQL_LEN_DATA_AT_EXEC_OFFSET     = word(  -100);
  {SQL_LEN_DATA_AT_EXEC(length)(-length+SQL_LEN_DATA_AT_EXEC_OFFSET)}
  {  }
  {  Defines for SQLGetInfo }
  {  }
  SQL_INFO_FIRST                  = word(     0);
  SQL_ACTIVE_CONNECTIONS          = word(     0);
  SQL_ACTIVE_STATEMENTS           = word(     1);
  SQL_DATA_SOURCE_NAME            = word(     2);
  SQL_DRIVER_HDBC                 = word(     3);
  SQL_DRIVER_HENV                 = word(     4);
  SQL_DRIVER_HSTMT                = word(     5);
  SQL_DRIVER_NAME                 = word(     6);
  SQL_DRIVER_VER                  = word(     7);
  SQL_FETCH_DIRECTION             = word(     8);
  SQL_ODBC_API_CONFORMANCE        = word(     9);
  SQL_ODBC_VER                    = word(    10);
  SQL_ROW_UPDATES                 = word(    11);
  SQL_ODBC_SAG_CLI_CONFORMANCE    = word(    12);
  SQL_SERVER_NAME                 = word(    13);
  SQL_SEARCH_PATTERN_ESCAPE       = word(    14);
  SQL_ODBC_SQL_CONFORMANCE        = word(    15);
  SQL_DBMS_NAME                   = word(    17);
  SQL_DBMS_VER                    = word(    18);
  SQL_ACCESSIBLE_TABLES           = word(    19);
  SQL_ACCESSIBLE_PROCEDURES       = word(    20);
  SQL_PROCEDURES                  = word(    21);
  SQL_CONCAT_NULL_BEHAVIOR        = word(    22);
  SQL_CURSOR_COMMIT_BEHAVIOR      = word(    23);
  SQL_CURSOR_ROLLBACK_BEHAVIOR    = word(    24);
  SQL_DATA_SOURCE_READ_ONLY       = word(    25);
  SQL_DEFAULT_TXN_ISOLATION       = word(    26);
  SQL_EXPRESSIONS_IN_ORDERBY      = word(    27);
  SQL_IDENTIFIER_CASE             = word(    28);
  SQL_IDENTIFIER_QUOTE_CHAR       = word(    29);
  SQL_MAX_COLUMN_NAME_LEN         = word(    30);
  SQL_MAX_CURSOR_NAME_LEN         = word(    31);
  SQL_MAX_OWNER_NAME_LEN          = word(    32);
  SQL_MAX_PROCEDURE_NAME_LEN      = word(    33);
  SQL_MAX_QUALIFIER_NAME_LEN      = word(    34);
  SQL_MAX_TABLE_NAME_LEN          = word(    35);
  SQL_MULT_RESULT_SETS            = word(    36);
  SQL_MULTIPLE_ACTIVE_TXN         = word(    37);
  SQL_OUTER_JOINS                 = word(    38);
  SQL_OWNER_TERM                  = word(    39);
  SQL_PROCEDURE_TERM              = word(    40);
  SQL_QUALIFIER_NAME_SEPARATOR    = word(    41);
  SQL_QUALIFIER_TERM              = word(    42);
  SQL_SCROLL_CONCURRENCY          = word(    43);
  SQL_SCROLL_OPTIONS              = word(    44);
  SQL_TABLE_TERM                  = word(    45);
  SQL_TXN_CAPABLE                 = word(    46);
  SQL_USER_NAME                   = word(    47);
  SQL_CONVERT_FUNCTIONS           = word(    48);
  SQL_NUMERIC_FUNCTIONS           = word(    49);
  SQL_STRING_FUNCTIONS            = word(    50);
  SQL_SYSTEM_FUNCTIONS            = word(    51);
  SQL_TIMEDATE_FUNCTIONS          = word(    52);
  SQL_CONVERT_BIGINT              = word(    53);
  SQL_CONVERT_BINARY              = word(    54);
  SQL_CONVERT_BIT                 = word(    55);
  SQL_CONVERT_CHAR                = word(    56);
  SQL_CONVERT_DATE                = word(    57);
  SQL_CONVERT_DECIMAL             = word(    58);
  SQL_CONVERT_DOUBLE              = word(    59);
  SQL_CONVERT_FLOAT               = word(    60);
  SQL_CONVERT_INTEGER             = word(    61);
  SQL_CONVERT_LONGVARCHAR         = word(    62);
  SQL_CONVERT_NUMERIC             = word(    63);
  SQL_CONVERT_REAL                = word(    64);
  SQL_CONVERT_smallInt            = word(    65);
  SQL_CONVERT_TIME                = word(    66);
  SQL_CONVERT_TIMESTAMP           = word(    67);
  SQL_CONVERT_TINYINT             = word(    68);
  SQL_CONVERT_VARBINARY           = word(    69);
  SQL_CONVERT_VARCHAR             = word(    70);
  SQL_CONVERT_LONGVARBINARY       = word(    71);
  SQL_TXN_ISOLATION_OPTION        = word(    72);
  SQL_ODBC_SQL_OPT_IEF            = word(    73);
  {*** ODBC SDK 1.0 Additions ***}
  SQL_CORRELATION_NAME            = word(    74);
  SQL_NON_NULLABLE_COLUMNS        = word(    75);
  {*** ODBC SDK 2.0 Additions ***}
  SQL_DRIVER_HLIB                 = word(    76);
  SQL_DRIVER_ODBC_VER             = word(    77);
  SQL_LOCK_TYPES                  = word(    78);
  SQL_POS_OPERATIONS              = word(    79);
  SQL_POSITIONED_STATEMENTS       = word(    80);
  SQL_GETDATA_EXTENSIONS          = word(    81);
  SQL_BOOKMARK_PERSISTENCE        = word(    82);
  SQL_STATIC_SENSITIVITY          = word(    83);
  SQL_FILE_USAGE                  = word(    84);
  SQL_NULL_COLLATION              = word(    85);
  SQL_ALTER_TABLE                 = word(    86);
  SQL_COLUMN_ALIAS                = word(    87);
  SQL_GROUP_BY                    = word(    88);
  SQL_KEYWORDS                    = word(    89);
  SQL_ORDER_BY_COLUMNS_IN_SELECT  = word(    90);
  SQL_OWNER_USAGE                 = word(    91);
  SQL_QUALIFIER_USAGE             = word(    92);
  SQL_QUOTED_IDENTIFIER_CASE      = word(    93);
  SQL_SPECIAL_CHARACTERS          = word(    94);
  SQL_SUBQUERIES                  = word(    95);
  SQL_UNION                       = word(    96);
  SQL_MAX_COLUMNS_IN_GROUP_BY     = word(    97);
  SQL_MAX_COLUMNS_IN_INDEX        = word(    98);
  SQL_MAX_COLUMNS_IN_ORDER_BY     = word(    99);
  SQL_MAX_COLUMNS_IN_SELECT       = word(   100);
  SQL_MAX_COLUMNS_IN_TABLE        = word(   101);
  SQL_MAX_INDEX_SIZE              = word(   102);
  SQL_MAX_ROW_SIZE_INCLUDES_LONG  = word(   103);
  SQL_MAX_ROW_SIZE                = word(   104);
  SQL_MAX_STATEMENT_LEN           = word(   105);
  SQL_MAX_TABLES_IN_SELECT        = word(   106);
  SQL_MAX_USER_NAME_LEN           = word(   107);
  SQL_MAX_CHAR_LITERAL_LEN        = word(   108);
  SQL_TIMEDATE_ADD_INTERVALS      = word(   109);
  SQL_TIMEDATE_DIFF_INTERVALS     = word(   110);
  SQL_NEED_LONG_DATA_LEN          = word(   111);
  SQL_MAX_BINARY_LITERAL_LEN      = word(   112);
  SQL_LIKE_ESCAPE_CLAUSE          = word(   113);
  SQL_QUALIFIER_LOCATION          = word(   114);
  SQL_INFO_LAST                   = word(SQL_QUALIFIER_LOCATION);
  SQL_INFO_DRIVER_START           = word(  1000);
  {  }
  {  SQL_CONVERT_*  return value bitmasks }
  {  }
  SQL_CVT_CHAR                    = longInt($00000001);
  SQL_CVT_NUMERIC                 = longInt($00000002);
  SQL_CVT_DECIMAL                 = longInt($00000004);
  SQL_CVT_INTEGER                 = longInt($00000008);
  SQL_CVT_smallInt                = longInt($00000010);
  SQL_CVT_FLOAT                   = longInt($00000020);
  SQL_CVT_REAL                    = longInt($00000040);
  SQL_CVT_DOUBLE                  = longInt($00000080);
  SQL_CVT_VARCHAR                 = longInt($00000100);
  SQL_CVT_LONGVARCHAR             = longInt($00000200);
  SQL_CVT_BINARY                  = longInt($00000400);
  SQL_CVT_VARBINARY               = longInt($00000800);
  SQL_CVT_BIT                     = longInt($00001000);
  SQL_CVT_TINYINT                 = longInt($00002000);
  SQL_CVT_BIGINT                  = longInt($00004000);
  SQL_CVT_DATE                    = longInt($00008000);
  SQL_CVT_TIME                    = longInt($00010000);
  SQL_CVT_TIMESTAMP               = longInt($00020000);
  SQL_CVT_LONGVARBINARY           = longInt($00040000);
  {  SQL_CONVERT_FUNCTIONS functions }
  SQL_FN_CVT_CONVERT              = longInt($00000001);
  {  SQL_STRING_FUNCTIONS functions }
  SQL_FN_STR_CONCAT               = longInt($00000001);
  SQL_FN_STR_INSERT               = longInt($00000002);
  SQL_FN_STR_LEFT                 = longInt($00000004);
  SQL_FN_STR_LTRIM                = longInt($00000008);
  SQL_FN_STR_LENGTH               = longInt($00000010);
  SQL_FN_STR_LOCATE               = longInt($00000020);
  SQL_FN_STR_LCASE                = longInt($00000040);
  SQL_FN_STR_REPEAT               = longInt($00000080);
  SQL_FN_STR_REPLACE              = longInt($00000100);
  SQL_FN_STR_RIGHT                = longInt($00000200);
  SQL_FN_STR_RTRIM                = longInt($00000400);
  SQL_FN_STR_SUBSTRING            = longInt($00000800);
  SQL_FN_STR_UCASE                = longInt($00001000);
  SQL_FN_STR_ASCII                = longInt($00002000);
  SQL_FN_STR_CHAR                 = longInt($00004000);
  SQL_FN_STR_DIFFERENCE           = longInt($00008000);
  SQL_FN_STR_LOCATE_2             = longInt($00010000);
  SQL_FN_STR_SOUNDEX              = longInt($00020000);
  SQL_FN_STR_SPACE                = longInt($00040000);
  {  SQL_NUMERIC_FUNCTIONS functions }
  SQL_FN_NUM_ABS                  = longInt($00000001);
  SQL_FN_NUM_ACOS                 = longInt($00000002);
  SQL_FN_NUM_ASIN                 = longInt($00000004);
  SQL_FN_NUM_ATAN                 = longInt($00000008);
  SQL_FN_NUM_ATAN2                = longInt($00000010);
  SQL_FN_NUM_CEILING              = longInt($00000020);
  SQL_FN_NUM_COS                  = longInt($00000040);
  SQL_FN_NUM_COT                  = longInt($00000080);
  SQL_FN_NUM_EXP                  = longInt($00000100);
  SQL_FN_NUM_FLOOR                = longInt($00000200);
  SQL_FN_NUM_LOG                  = longInt($00000400);
  SQL_FN_NUM_MOD                  = longInt($00000800);
  SQL_FN_NUM_SIGN                 = longInt($00001000);
  SQL_FN_NUM_SIN                  = longInt($00002000);
  SQL_FN_NUM_SQRT                 = longInt($00004000);
  SQL_FN_NUM_TAN                  = longInt($00008000);
  SQL_FN_NUM_PI                   = longInt($00010000);
  SQL_FN_NUM_RAND                 = longInt($00020000);
  SQL_FN_NUM_DEGREES              = longInt($00040000);
  SQL_FN_NUM_LOG10                = longInt($00080000);
  SQL_FN_NUM_POWER                = longInt($00100000);
  SQL_FN_NUM_RADIANS              = longInt($00200000);
  SQL_FN_NUM_ROUND                = longInt($00400000);
  SQL_FN_NUM_TRUNCATE             = longInt($00800000);
  {  SQL_TIMEDATE_FUNCTIONS functions }
  SQL_FN_TD_NOW                   = longInt($00000001);
  SQL_FN_TD_CURDATE               = longInt($00000002);
  SQL_FN_TD_DAYOFMONTH            = longInt($00000004);
  SQL_FN_TD_DAYOFWEEK             = longInt($00000008);
  SQL_FN_TD_DAYOFYEAR             = longInt($00000010);
  SQL_FN_TD_MONTH                 = longInt($00000020);
  SQL_FN_TD_QUARTER               = longInt($00000040);
  SQL_FN_TD_WEEK                  = longInt($00000080);
  SQL_FN_TD_YEAR                  = longInt($00000100);
  SQL_FN_TD_CURTIME               = longInt($00000200);
  SQL_FN_TD_HOUR                  = longInt($00000400);
  SQL_FN_TD_MINUTE                = longInt($00000800);
  SQL_FN_TD_SECOND                = longInt($00001000);
  SQL_FN_TD_TIMESTAMPADD          = longInt($00002000);
  SQL_FN_TD_TIMESTAMPDIFF         = longInt($00004000);
  SQL_FN_TD_DAYNAME               = longInt($00008000);
  SQL_FN_TD_MONTHNAME             = longInt($00010000);
  {  SQL_SYSTEM_FUNCTIONS functions }
  SQL_FN_SYS_USERNAME             = longInt($00000001);
  SQL_FN_SYS_DBNAME               = longInt($00000002);
  SQL_FN_SYS_IFNULL               = longInt($00000004);
  {  SQL_TIMEDATE_ADD_INTERVALS and SQL_TIMEDATE_DIFF_INTERVALS functions }
  SQL_FN_TSI_FRAC_SECOND          = longInt($00000001);
  SQL_FN_TSI_SECOND               = longInt($00000002);
  SQL_FN_TSI_MINUTE               = longInt($00000004);
  SQL_FN_TSI_HOUR                 = longInt($00000008);
  SQL_FN_TSI_DAY                  = longInt($00000010);
  SQL_FN_TSI_WEEK                 = longInt($00000020);
  SQL_FN_TSI_MONTH                = longInt($00000040);
  SQL_FN_TSI_QUARTER              = longInt($00000080);
  SQL_FN_TSI_YEAR                 = longInt($00000100);
  {  }
  {  SQL_ODBC_API_CONFORMANCE values }
  SQL_OAC_NONE                    = word($0000);
  SQL_OAC_LEVEL1                  = word($0001);
  SQL_OAC_LEVEL2                  = word($0002);
  {  SQL_ODBC_SAG_CLI_CONFORMANCE values }
  SQL_OSCC_NOT_COMPLIANT          = word($0000);
  SQL_OSCC_COMPLIANT              = word($0001);
  {  SQL_ODBC_SQL_CONFORMANCE values }
  SQL_OSC_MINIMUM                 = word($0000);
  SQL_OSC_CORE                    = word($0001);
  SQL_OSC_EXTENDED                = word($0002);
  {  SQL_CONCAT_NULL_BEHAVIOR values }
  SQL_CB_NULL                     = word($0000);
  SQL_CB_NON_NULL                 = word($0001);
  {  SQL_CURSOR_COMMIT_BEHAVIOR and SQL_CURSOR_ROLLBACK_BEHAVIOR values }
  SQL_CB_DELETE                   = word($0000);
  SQL_CB_CLOSE                    = word($0001);
  SQL_CB_PRESERVE                 = word($0002);
  {  SQL_IDENTIFIER_CASE values }
  SQL_IC_UPPER                    = word($0001);
  SQL_IC_LOWER                    = word($0002);
  SQL_IC_SENSITIVE                = word($0003);
  SQL_IC_MIXED                    = word($0004);
  {  SQL_TXN_CAPABLE values }
  SQL_TC_NONE                     = word($0000);
  SQL_TC_DML                      = word($0001);
  SQL_TC_ALL                      = word($0002);
  SQL_TC_DDL_COMMIT               = word($0003);
  SQL_TC_DDL_IGNORE               = word($0004);
  {  SQL_SCROLL_OPTIONS masks }
  SQL_SO_FORWARD_ONLY             = longInt($00000001);
  SQL_SO_KEYSET_DRIVEN            = longInt($00000002);
  SQL_SO_DYNAMIC                  = longInt($00000004);
  SQL_SO_MIXED                    = longInt($00000008);
  SQL_SO_STATIC                   = longInt($00000010);
  {  SQL_SCROLL_CONCURRENCY masks }
  SQL_SCCO_READ_ONLY              = longInt($00000001);
  SQL_SCCO_LOCK                   = longInt($00000002);
  SQL_SCCO_OPT_ROWVER             = longInt($00000004);
  SQL_SCCO_OPT_VALUES             = longInt($00000008);
  {  SQL_FETCH_DIRECTION masks    }
  SQL_FD_FETCH_NEXT               = longInt($00000001);
  SQL_FD_FETCH_FIRST              = longInt($00000002);
  SQL_FD_FETCH_LAST               = longInt($00000004);
  SQL_FD_FETCH_PRIOR              = longInt($00000008);
  SQL_FD_FETCH_ABSOLUTE           = longInt($00000010);
  SQL_FD_FETCH_RELATIVE           = longInt($00000020);
  SQL_FD_FETCH_RESUME             = longInt($00000040);
  SQL_FD_FETCH_BOOKMARK           = longInt($00000080);
  {  SQL_TXN_ISOLATION_OPTION masks }
  SQL_TXN_READ_UNCOMMITTED        = longInt($00000001);
  SQL_TXN_READ_COMMITTED          = longInt($00000002);
  SQL_TXN_REPEATABLE_READ         = longInt($00000004);
  SQL_TXN_SERIALIZABLE            = longInt($00000008);
  SQL_TXN_VERSIONING              = longInt($00000010);
  {  SQL_CORRELATION_NAME values }
  SQL_CN_NONE                     = word($0000);
  SQL_CN_DIFFERENT                = word($0001);
  SQL_CN_ANY                      = word($0002);
  {  SQL_NON_NULLABLE_COLUMNS values }
  SQL_NNC_NULL                    = word($0000);
  SQL_NNC_NON_NULL                = word($0001);
  {  SQL_NULL_COLLATION values    }
  SQL_NC_HIGH                     = word($0000);
  SQL_NC_LOW                      = word($0001);
  SQL_NC_START                    = word($0002);
  SQL_NC_END                      = word($0004);
  {  SQL_FILE_USAGE values }
  SQL_FILE_NOT_SUPPORTED          = word($0000);
  SQL_FILE_TABLE                  = word($0001);
  SQL_FILE_QUALIFIER              = word($0002);
  {  SQL_GETDATA_EXTENSIONS values }
  SQL_GD_ANY_COLUMN               = longInt($00000001);
  SQL_GD_ANY_ORDER                = longInt($00000002);
  SQL_GD_BLOCK                    = longInt($00000004);
  SQL_GD_BOUND                    = longInt($00000008);
  {  SQL_ALTER_TABLE values }
  SQL_AT_ADD_COLUMN               = longInt($00000001);
  SQL_AT_DROP_COLUMN              = longInt($00000002);
  {  SQL_POSITIONED_STATEMENTS masks }
  SQL_PS_POSITIONED_DELETE        = longInt($00000001);
  SQL_PS_POSITIONED_UPDATE        = longInt($00000002);
  SQL_PS_SELECT_FOR_UPDATE        = longInt($00000004);
  {  SQL_GROUP_BY values }
  SQL_GB_NOT_SUPPORTED            = word($0000);
  SQL_GB_GROUP_BY_EQUALS_SELECT   = word($0001);
  SQL_GB_GROUP_BY_CONTAINS_SELECT = word($0002);
  SQL_GB_NO_RELATION              = word($0003);
  {  SQL_OWNER_USAGE masks }
  SQL_OU_DML_STATEMENTS           = longInt($00000001);
  SQL_OU_PROCEDURE_INVOCATION     = longInt($00000002);
  SQL_OU_TABLE_DEFINITION         = longInt($00000004);
  SQL_OU_INDEX_DEFINITION         = longInt($00000008);
  SQL_OU_PRIVILEGE_DEFINITION     = longInt($00000010);
  {  SQL_QUALIFIER_USAGE masks }
  SQL_QU_DML_STATEMENTS           = longInt($00000001);
  SQL_QU_PROCEDURE_INVOCATION     = longInt($00000002);
  SQL_QU_TABLE_DEFINITION         = longInt($00000004);
  SQL_QU_INDEX_DEFINITION         = longInt($00000008);
  SQL_QU_PRIVILEGE_DEFINITION     = longInt($00000010);
  {  SQL_SUBQUERIES masks }
  SQL_SQ_COMPARISON               = longInt($00000001);
  SQL_SQ_EXISTS                   = longInt($00000002);
  SQL_SQ_IN                       = longInt($00000004);
  SQL_SQ_QUANTIFIED               = longInt($00000008);
  SQL_SQ_CORRELATED_SUBQUERIES    = longInt($00000010);
  {  SQL_UNION masks }
  SQL_U_UNION                     = longInt($00000001);
  SQL_U_UNION_ALL                 = longInt($00000002);
  {  SQL_BOOKMARK_PERSISTENCE values }
  SQL_BP_CLOSE                    = longInt($00000001);
  SQL_BP_DELETE                   = longInt($00000002);
  SQL_BP_DROP                     = longInt($00000004);
  SQL_BP_TRANSACTION              = longInt($00000008);
  SQL_BP_UPDATE                   = longInt($00000010);
  SQL_BP_OTHER_HSTMT              = longInt($00000020);
  SQL_BP_SCROLL                   = longInt($00000040);
  {  SQL_STATIC_SENSITIVITY values }
  SQL_SS_ADDITIONS                = longInt($00000001);
  SQL_SS_DELETIONS                = longInt($00000002);
  SQL_SS_UPDATES                  = longInt($00000004);
  {  SQL_LOCK_TYPESL masks }
  SQL_LCK_NO_CHANGE               = longInt($00000001);
  SQL_LCK_EXCLUSIVE               = longInt($00000002);
  SQL_LCK_UNLOCK                  = longInt($00000004);
  {  SQL_POS_OPERATIONS masks }
  SQL_POS_POSITION                = longInt($00000001);
  SQL_POS_REFRESH                 = longInt($00000002);
  SQL_POS_UPDATE                  = longInt($00000004);
  SQL_POS_DELETE                  = longInt($00000008);
  SQL_POS_ADD                     = longInt($00000010);
  {  SQL_QUALIFIER_LOCATION values }
  SQL_QL_START                    = longInt($00000001);
  SQL_QL_END                      = longInt($00000002);
  {  options for SQLGetStmtOption/SQLSetStmtOption }
  SQL_QUERY_TIMEOUT               = word(     0);
  SQL_MAX_ROWS                    = word(     1);
  SQL_NOSCAN                      = word(     2);
  SQL_MAX_LENGTH                  = word(     3);
  SQL_ASYNC_ENABLE                = word(     4);
  SQL_BIND_TYPE                   = word(     5);
  SQL_CURSOR_TYPE                 = word(     6);
  SQL_CONCURRENCY                 = word(     7);
  SQL_KEYSET_SIZE                 = word(     8);
  SQL_ROWSET_SIZE                 = word(     9);
  SQL_SIMULATE_CURSOR             = word(    10);
  SQL_RETRIEVE_DATA               = word(    11);
  SQL_USE_BOOKMARKS               = word(    12);
  SQL_GET_BOOKMARK                = word(    13);      (* GetStmtOption Only *)
  SQL_ROW_NUMBER                  = word(    14);      (* GetStmtOption Only *)
  SQL_STMT_OPT_MAX                = word(SQL_ROW_NUMBER   );
  SQL_STMT_OPT_MIN                = word(SQL_QUERY_TIMEOUT);
  {  SQL_QUERY_TIMEOUT options }
  SQL_QUERY_TIMEOUT_DEFAULT       = longInt( 0);
  {  SQL_MAX_ROWS options }
  SQL_MAX_ROWS_DEFAULT            = longInt( 0);
  {  SQL_NOSCAN options }
  SQL_NOSCAN_OFF                  = longInt( 0);       { 0.0 FALSE }
  SQL_NOSCAN_ON                   = longInt( 1);       { 1.0 TRUE }
  SQL_NOSCAN_DEFAULT              = longInt(SQL_NOSCAN_OFF);
  {  SQL_MAX_LENGTH options }
  SQL_MAX_LENGTH_DEFAULT          = longInt( 0);
  {  SQL_ASYNC_ENABLE options }
  SQL_ASYNC_ENABLE_OFF            = longInt( 0);
  SQL_ASYNC_ENABLE_ON             = longInt( 1);
  SQL_ASYNC_ENABLE_DEFAULT        = longInt(SQL_ASYNC_ENABLE_OFF);
  {  SQL_BIND_TYPE options }
  SQL_BIND_BY_COLUMN              = longInt( 0);
  {  SQL_CONCURRENCY options }
  SQL_CONCUR_READ_ONLY            = word(    1);
  SQL_CONCUR_LOCK                 = word(    2);
  SQL_CONCUR_ROWVER               = word(    3);
  SQL_CONCUR_VALUES               = word(    4);
  {  SQL_CURSOR_TYPE options }
  SQL_CURSOR_FORWARD_ONLY         = longInt( 0);
  SQL_CURSOR_KEYSET_DRIVEN        = longInt( 1);
  SQL_CURSOR_DYNAMIC              = longInt( 2);
  SQL_CURSOR_STATIC               = longInt( 3);
  {  SQL_ROWSET_SIZE options }
  SQL_ROWSET_SIZE_DEFAULT         = longInt( 1);
  {  SQL_KEYSET_SIZE options }
  SQL_KEYSET_SIZE_DEFAULT         = longInt( 0);
  {  SQL_SIMULATE_CURSOR options }
  SQL_SC_NON_UNIQUE               = longInt( 0);
  SQL_SC_TRY_UNIQUE               = longInt( 1);
  SQL_SC_UNIQUE                   = longInt( 2);
  {  SQL_RETRIEVE_DATA options }
  SQL_RD_OFF                      = longInt( 0);
  SQL_RD_ON                       = longInt( 1);
  SQL_RD_DEFAULT                  = longInt(SQL_RD_ON);
  {  SQL_USE_BOOKMARKS options }
  SQL_UB_OFF                      = longInt( 0);
  SQL_UB_ON                       = longInt( 1);
  SQL_UB_DEFAULT                  = longInt(SQL_UB_ON);
  {  options for SQLSetConnectOption/SQLGetConnectOption }
  SQL_ACCESS_MODE                 = word(    101);
  SQL_AUTOCOMMIT                  = word(    102);
  SQL_LOGIN_TIMEOUT               = word(    103);
  SQL_OPT_TRACE                   = word(    104);
  SQL_OPT_TRACEFILE               = word(    105);
  SQL_TRANSLATE_DLL               = word(    106);
  SQL_TRANSLATE_OPTION            = word(    107);
  SQL_TXN_ISOLATION               = word(    108);
  SQL_CURRENT_QUALIFIER           = word(    109);
  SQL_ODBC_CURSORS                = word(    110);
  SQL_QUIET_MODE                  = word(    111);
  SQL_PACKET_SIZE                 = word(    112);
  SQL_CONN_OPT_MAX                = word(SQL_PACKET_SIZE);
  SQL_CONNECT_OPT_DRVR_START      = word(   1000);
  SQL_CONN_OPT_MIN                = word(SQL_ACCESS_MODE);
  {  SQL_ACCESS_MODE options  }
  SQL_MODE_READ_WRITE             = longInt( 0);
  SQL_MODE_READ_ONLY              = longInt( 1);
  SQL_MODE_DEFAULT                = longInt(SQL_MODE_READ_WRITE);
  {  SQL_AUTOCOMMIT options  }
  SQL_AUTOCOMMIT_OFF              = longInt( 0);
  SQL_AUTOCOMMIT_ON               = longInt( 1);
  SQL_AUTOCOMMIT_DEFAULT          = longInt(SQL_AUTOCOMMIT_ON);
  {  SQL_LOGIN_TIMEOUT options  }
  SQL_LOGIN_TIMEOUT_DEFAULT       = longInt( 15);
  {  SQL_OPT_TRACE options  }
  SQL_OPT_TRACE_OFF               = longInt( 0);
  SQL_OPT_TRACE_ON                = longInt( 1);
  SQL_OPT_TRACE_DEFAULT           = longInt(SQL_OPT_TRACE_OFF);
  SQL_OPT_TRACE_FILE_DEFAULT      = '\SQL.LOG';
  {  SQL_ODBC_CURSORS options  }
  SQL_CUR_USE_IF_NEEDED           = longInt( 0);
  SQL_CUR_USE_ODBC                = longInt( 1);
  SQL_CUR_USE_DRIVER              = longInt( 2);
  SQL_CUR_DEFAULT                 = longInt(SQL_CUR_USE_DRIVER);
  {  Column types and scopes in SQLSpecialColumns.   }
  SQL_BEST_ROWID                  = word(    1);
  SQL_ROWVER                      = word(    2);
  SQL_SCOPE_CURROW                = word(    0);
  SQL_SCOPE_TRANSACTION           = word(    1);
  SQL_SCOPE_SESSION               = word(    2);
  {  Defines for SQLSetPos  }
  SQL_ENTIRE_ROWSET               = word(    0);
  {  Operations in SQLSetPos  }
  SQL_POSITION                    = word(    0);       { 0.0 FALSE  }
  SQL_REFRESH                     = word(    1);       { 1.0 TRUE  }
  SQL_UPDATE                      = word(    2);
  SQL_DELETE                      = word(    3);
  SQL_ADD                         = word(    4);
  {  Lock options in SQLSetPos  }
  SQL_LOCK_NO_CHANGE              = word(    0);       { 0.0 FALSE  }
  SQL_LOCK_EXCLUSIVE              = word(    1);       { 1.0 TRUE  }
  SQL_LOCK_UNLOCK                 = word(    2);
  {  Level 3 }
  SQL_ATTR_ODBC_VERSION           = 200;
  SQL_OV_ODBC1                    = 1;
  SQL_OV_ODBC2                    = 2;
  SQL_OV_ODBC3                    = 3;
  SQL_ATTR_CONNECTION_POOLING     = 201;
  SQL_ATTR_CP_MATCH               = 202;
  SQL_ATTR_ACCESS_MODE            = SQL_ACCESS_MODE;
  SQL_ATTR_AUTOCOMMIT             = SQL_AUTOCOMMIT;
  SQL_ATTR_CONNECTION_TIMEOUT     = 113;
  SQL_ATTR_CURRENT_CATALOG        = SQL_CURRENT_QUALIFIER;
  SQL_ATTR_DISCONNECT_BEHAVIOR    = 114;
  SQL_ATTR_ENLIST_IN_DTC          = 1207;
  SQL_ATTR_ENLIST_IN_XA           = 1208;
  SQL_ATTR_LOGIN_TIMEOUT          = SQL_LOGIN_TIMEOUT;
  SQL_ATTR_ODBC_CURSORS           = SQL_ODBC_CURSORS;
  SQL_ATTR_PACKET_SIZE            = SQL_PACKET_SIZE;
  SQL_ATTR_QUIET_MODE             = SQL_QUIET_MODE;
  SQL_ATTR_TRACE                  = SQL_OPT_TRACE;
  SQL_ATTR_TRACEFILE              = SQL_OPT_TRACEFILE;
  SQL_ATTR_TRANSLATE_LIB          = SQL_TRANSLATE_DLL;
  SQL_ATTR_TRANSLATE_OPTION       = SQL_TRANSLATE_OPTION;
  SQL_ATTR_TXN_ISOLATION          = SQL_TXN_ISOLATION;
  SQL_ATTR_CONNECTION_DEAD        = 1209;    { GetConnectAttr only }
  SQL_ATTR_ANSI_APP               = 115;
  {  }

type
  TSQL_IMPLEMENTED_FUNCTIONS = array [0..SQL_EXT_API_END] of boolean;
  TSQL_IMPLEMENTED_FUNCTIONS_API_CODES = array [0..SQL_EXT_API_END] of smallInt;
  TSQL_IMPLEMENTED_FUNCTIONS_ADDR = array [0..SQL_EXT_API_END] of pointer;

  {  1. }
  TSQLAllocConnect = Function(
    HENV     : lpVoid;
    Var HDBC : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  2. }
  TSQLAllocEnv = Function(
    Var HENV : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  3. }
  TSQLAllocStmt = Function(
    HDBC      : lpVoid;
    Var HSTMT : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  4. }
  TSQLBindCol = Function(
    HSTMT        : lpVoid;
    iCol         : word;
    fCType       : smallInt;
    Var rgbValue;
    cbValueMax   : longInt;
    Var pcbValue : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  5. }
  TSQLCancel = Function(
    HSTMT : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  6. }
  TSQLColAttributes = Function(
    HSTMT       : lpVoid;
    icol        : word;
    fDescType   : word;
    Var rgbDesc;
    cbDescMax   : smallInt;
    Var pcbDesc : smallInt;
    Var pfDesc  : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  7. }
  TSQLConnect = Function(
    HDBC  : lpVoid;
    szDSN : PChar;
    cbDSN : smallInt;
    szUID : PChar;
    cbUID : smallInt;
    szPWD : PChar;
    cbPWD : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  8. }
  TSQLDescribeCol = Function(
    HSTMT          : lpVoid;
    icol           : word;
    szColName      : PChar;
    cbColNameMax   : smallInt;
    Var pcbColName : smallInt;
    Var pfSqlType  : smallInt;
    Var pcbColDef  : longInt;
    Var pibScale   : smallInt;
    Var pfNullable : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  {  9. }
  TSQLDisconnect = Function(
    HDBC  : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 10. }
  TSQLError = Function(
    HENV              : lpVoid;
    HDBC              : lpVoid;
    HSTMT             : lpVoid;
    szSQLState        : PChar;
    Var pfNativeError : longInt;
    szErrorMsg        : PChar;
    cbErrorMsgMax     : smallInt;
    Var pcbErrorMsg   : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 11. }
  TSQLExecDirect = Function(
    HSTMT     : lpVoid;
    szSqlStr  : PChar;
    cbSqlStr  : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 12. }
  TSQLExecute = Function(
    HSTMT    : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 13. }
  TSQLFetch = Function(
    HSTMT        : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 14. }
  TSQLFreeConnect = Function(
    HDBC  : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 15. }
  TSQLFreeEnv = Function(
    HENV  : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 16. }
  TSQLFreeStmt = Function(
    HSTMT   : lpVoid;
    fOption : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 17. }
  TSQLGetCursorName = Function(
    HSTMT         : lpVoid;
    szCursor      : PChar;
    cbCursorMax   : smallInt;
    Var pcbCursor : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 18. }
  TSQLNumResultCols = Function(
    HSTMT    : lpVoid;
    VAR nCOL : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 19. }
  TSQLPrepare = Function(
    HSTMT    : lpVoid;
    szSQLStr : PChar;
    cbSQLStr : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 20. }
  TSQLRowCount = Function(
    HSTMT    : lpVoid;
    VAR nROW : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 21. }
  TSQLSetCursorName = Function(
    HSTMT    : lpVoid;
    szCursor : PChar;
    cbCursor : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 22. -> SQLBindParameter --> 72. }
  TSQLSetParam = Function(
    HSTMT        : lpVoid;
    ipar         : word;
    fCType       : smallInt;
    fSqlType     : smallInt;
    cbColDef     : longInt;
    ibScale      : smallInt;
    Var rgbValue;
    Var pcbValue : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 23. }
  TSQLTransact = Function(
    HENV    : lpVoid;
    HDBC    : lpVoid;
    fType   : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { LEVEL 1 FUNCTIONS }
  { 40. }
  TSQLColumns = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt;
    szColumnName     : PChar;
    cbColumnName     : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 41. }
  TSQLDriverConnect = Function(
    HDBC              : lpVoid;
    HWND_SQL          : {$IFDEF LINUX}Pointer{$ELSE}HWND{$ENDIF};
    szConnStrIn       : PChar;
    cbConnStrIn       : smallInt;
    szConnStrOut      : PChar;
    cbConnStrOutMax   : smallInt;
    Var pcbConnStrOut : smallInt;
    fDriverCompletion : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 42. }
  TSQLGetConnectOption = Function(
    HDBC       : lpVoid;
    fOption    : word;
    Var vParam : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 43. }
  TSQLGetData = Function(
    HSTMT        : lpVoid;
    icol         : word;
    fCType       : smallInt;
    Var rgbValue;
    cbValueMax   : longInt;
    Var pcbValue : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 44. }
  TSQLGetFunctions = Function(
    HDBC         : lpVoid;
    fFunction    : word;
    Var pfExists : WordBool
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 45. }
  TSQLGetInfo = Function(
    HDBC             : lpVoid;
    fInfoType        : word;
    Var rgbInfoValue;
    cbInfoValueMax   : smallInt;
    Var pcbInfoValue : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 46. }
  TSQLGetStmtOption = Function(
    HSTMT       : lpVoid;
    fOption     : word;
    Var pvParam : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 47. }
  TSQLGetTypeInfo = Function(
    HSTMT    : lpVoid;
    fSqlType : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 48. }
  TSQLParamData = Function(
    HSTMT         : lpVoid;
    Var prgbValue : pointer
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 49. }
  TSQLPutData = Function(
    HSTMT        : lpVoid;
    Var rgbValue;
    cbValue      : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 50. }
  TSQLSetConnectOption = Function(
    HDBC     : lpVoid;
    fOption  : word;
    vParam   : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 51. }
  TSQLSetStmtOption = Function(
    HSTMT    : lpVoid;
    fOption  : word;
    vParam   : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 52. }
  TSQLSpecialColumns = Function(
    HSTMT            : lpVoid;
    fColType         : word;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt;
    fScope           : word;
    fNullable        : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 53. }
  TSQLStatistics = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt;
    fUnique          : word;
    fAccuracy        : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 54. }
  TSQLTables = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt;
    szTableType      : PChar;
    cbTableType      : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { LEVEL 2 FUNCTIONS }
  { 55. }
  TSQLBrowseConnect = Function(
    HDBC              : lpVoid;
    szConnStrIn       : PChar;
    cbConnStrIn       : smallInt;
    szConnStrOut      : PChar;
    cbConnStrOutMax   : smallInt;
    Var pcbConnStrOut : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 56. }
  TSQLColumnPrivileges = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt;
    szColumnName     : PChar;
    cbColumnName     : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 57. }
  TSQLDataSources = Function(
    HENV              : lpVoid;
    fDirection        : word;
    szDSN             : PChar;
    cbDSNMax          : smallInt;
    Var pcbDSN        : smallInt;
    szDescription     : PChar;
    cbDescriptionMax  : smallInt;
    Var pcbDescription: smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 58. }
  TSQLDescribeParam = Function(
    HSTMT          : lpVoid;
    iPar           : word;
    Var pfSqlType  : smallInt;
    Var pcbColDef  : longInt;
    Var pibScale   : smallInt;
    Var pfNullable : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 59. }
  TSQLExtendedFetch = Function(
    HSTMT            : lpVoid;
    fFetchType       : word;
    iRow             : longInt;
    Var pcRow        : longInt;
    Var rgfRowStatus : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 60. }
  TSQLForeignKeys = Function(
    HSTMT              : lpVoid;
    szPkTableQualifier : PChar;
    cbPkTableQualifier : smallInt;
    szPkTableOwner     : PChar;
    cbPkTableOwner     : smallInt;
    szPkTableName      : PChar;
    cbPkTableName      : smallInt;
    szFkTableQualifier : PChar;
    cbFkTableQualifier : smallInt;
    szFkTableOwner     : PChar;
    cbFkTableOwner     : smallInt;
    szFkTableName      : PChar;
    cbFkTableName      : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 61. }
  TSQLMoreResults = Function(
      HSTMT : lpVoid
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 62. }
  TSQLNativeSql = Function(
    HDBC          : lpVoid;
    szSqlStrIn    : PChar;
    cbSqlStrIn    : longInt;
    szSqlStr      : PChar;
    cbSqlStrMax   : longInt;
    Var pcbSqlStr : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 63. }
  TSQLNumParams = Function(
    HSTMT     : lpVoid;
    Var pcPar : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 64. }
  TSQLParamOptions = Function(
    HSTMT     : lpVoid;
    cRow      : longInt;
    Var piRow : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 65. }
  TSQLPrimaryKeys = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 66. }
  TSQLProcedureColumns = Function(
    HSTMT            : lpVoid;
    szProcQualifier  : PChar;
    cbProcQualifier  : smallInt;
    szProcOwner      : PChar;
    cbProcOwner      : smallInt;
    szProcName       : PChar;
    cbProcName       : smallInt;
    szColumnName     : PChar;
    cbColumnName     : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 67. }
  TSQLProcedures = Function(
    HSTMT           : lpVoid;
    szProcQualifier : PChar;
    cbProcQualifier : smallInt;
    szProcOwner     : PChar;
    cbProcOwner     : smallInt;
    szProcName      : PChar;
    cbProcName      : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 68. }
  TSQLSetPos = Function(
    HSTMT   : lpVoid;
    iRow    : word;
    fOption : word;
    fLock   : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 69.  -> SQLSetStmtOptions --> 51. }
  TSQLSetScrollOptions = Function(
    HSTMT        : lpVoid;
    fConcurrency : word;
    crowKeyset   : longInt;
    crowRowset   : word
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 70. }
  TSQLTablePrivileges = Function(
    HSTMT            : lpVoid;
    szTableQualifier : PChar;
    cbTableQualifier : smallInt;
    szTableOwner     : PChar;
    cbTableOwner     : smallInt;
    szTableName      : PChar;
    cbTableName      : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { SDK 2.0 ADDITIONS }
  { 71. }
  TSQLDrivers = Function(
    HENV               : lpVoid;
    fDirection         : word;
    szDriverDesc       : PChar;
    cbDriverDescMax    : smallInt;
    Var pcbDriverDesc  : smallInt;
    szDriverAttributes : PChar;
    cbDrvrAttrMax      : smallInt;
    Var pcbDrvrAttr    : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 72. }
  TSQLBindParameter = Function(
    HSTMT        : lpVoid;
    ipar         : word;
    fParamType   : smallInt;
    fCType       : smallInt;
    fSqlType     : smallInt;
    cbColDef     : longInt;
    ibScale      : smallInt;
    Var rgbValue;
    cbValueMax   : longInt;
    Var pcbValue : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { EXTRA FUNCTIONS !!! not exist in general ODBC driver !!! }
  { 73. }
  TSQLOpenTable = Function(
    HSTMT        : lpVoid;
    szTableName  : PChar;
    cbTableName  : smallInt;
    szTableOwner : PChar;
    cbTableOwner : smallInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { LEVEL 3 FUNCTIONS }
  { 1016. }
  TSQLSetConnectAttr = Function(
    HDBC      : lpVoid;
    Attribute : longInt;
    var szValue;
    cbValue   : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};
  { 1019. }
  TSQLSetEnvAttr = Function(
    HENV      : lpVoid;
    Attribute : longInt;
    var szValue;
    cbValue   : longInt
  ) : smallInt; {$IFDEF LINUX}cdecl{$ELSE}stdcall{$ENDIF};

var
  SQL_IMPLEMENTED_FUNCTIONS: TSQL_IMPLEMENTED_FUNCTIONS; // in ODBC.dll
  SQL_IMPLEMENTED_FUNCTIONS_ADDR: TSQL_IMPLEMENTED_FUNCTIONS_ADDR; // in ODBC.dll
  SQL_IMPLEMENTED_FUNCTIONS_API_CODES: TSQL_IMPLEMENTED_FUNCTIONS_API_CODES;

{----------------------O D B C  F u n c t i o n s---------------------------}
{  1. }
Function SQLAllocConnect(HENV: lpVoid; Var HDBC: lpVoid): smallInt;
{  2. }
Function SQLAllocEnv(Var HENV: lpVoid): smallInt;
{  3. }
Function SQLAllocStmt(HDBC: lpVoid; Var HSTMT: lpVoid): smallInt;
{  4. }
Function SQLBindCol(
  HSTMT: lpVoid;
  iCol: word; fCType: smallInt;
  Var rgbValue; cbValueMax: longInt; Var pcbValue: longInt
): smallInt;
{  5. }
Function SQLCancel(HSTMT: lpVoid): smallInt;
{  6. }
Function SQLColAttributes(
  HSTMT: lpVoid;
  iCol: word; fDescType: word; Var rgbDesc; cbDescMax: smallInt;
  Var pcbDesc : smallInt; Var pfDesc: longInt
): smallInt;
{  7. }
Function SQLConnect(
  HDBC: lpVoid; szDSN: PChar; cbDSN: smallInt;
  szUID: PChar; cbUID: smallInt; szPWD: PChar; cbPWD: smallInt
): smallInt;
{  8. }
Function SQLDescribeCol(
  HSTMT: lpVoid; iCol: word; szColName: PChar; cbColNameMax: smallInt;
  Var pcbColName: smallInt; Var pfSqlType: smallInt; Var pcbColDef: longInt;
  Var pibScale: smallInt; Var pfNullable : smallInt
): smallInt;
{  9. }
Function SQLDisconnect(HDBC: lpVoid): smallInt;
{ 10. }
Function SQLError(
  HENV: lpVoid; HDBC: lpVoid; HSTMT: lpVoid;
  szSQLState: PChar; Var pfNativeError: longInt;
  szErrorMsg: PChar; cbErrorMsgMax: smallInt; Var pcbErrorMsg: smallInt
): smallInt;
{ 11. }
Function SQLExecDirect(HSTMT: lpVoid; szSqlStr: PChar; cbSqlStr: longInt): smallInt;
{ 12. }
Function SQLExecute(HSTMT: lpVoid): smallInt;
{ 13. }
Function SQLFetch(HSTMT: lpVoid): smallInt;
{ 14. }
Function SQLFreeConnect(HDBC: lpVoid): smallInt;
{ 15. }
Function SQLFreeEnv(HENV: lpVoid): smallInt;
{ 16. }
Function SQLFreeStmt(HSTMT: lpVoid; fOption : smallInt): smallInt;
{ 17. }
Function SQLGetCursorName(
  HSTMT: lpVoid; szCursor: PChar; cbCursorMax: smallInt; Var pcbCursor: smallInt
): smallInt;
{ 18. }
Function SQLNumResultCols(HSTMT: lpVoid; VAR nCOL: smallInt): smallInt;
{ 19. }
Function SQLPrepare(HSTMT: lpVoid; szSQLStr: PChar; cbSQLStr: longInt): smallInt;
{ 20. }
Function SQLRowCount(HSTMT: lpVoid; VAR nROW: longInt): smallInt;
{ 21. }
Function SQLSetCursorName(HSTMT: lpVoid; szCursor: PChar; cbCursor: smallInt): smallInt;
{ 22. -> SQLBindParameter --> 72. }
Function SQLSetParam(
  HSTMT: lpVoid; iPar: word; fCType: smallInt; fSqlType: smallInt;
  cbColDef: longInt; ibScale: smallInt; Var rgbValue; Var pcbValue: longInt
): smallInt;
{ 23. }
Function SQLTransact(HENV: lpVoid; HDBC: lpVoid; fType: word): smallInt;
{ LEVEL 1 FUNCTIONS }
{ 40. }
Function SQLColumns(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt;
  szTableName: PChar; cbTableName: smallInt; szColumnName: PChar; cbColumnName: smallInt
): smallInt;
{ 41. }
Function SQLDriverConnect(
  HDBC: lpVoid; HWND_SQL: {$IFDEF LINUX}Pointer{$ELSE}HWND{$ENDIF};
  szConnStrIn: PChar; cbConnStrIn: smallInt;
  szConnStrOut: PChar; cbConnStrOutMax: smallInt; Var pcbConnStrOut: smallInt;
  fDriverCompletion: word
): smallInt;
{ 42. }
Function SQLGetConnectOption(HDBC: lpVoid; fOption: word;Var vParam: longInt): smallInt;
{ 43. }
Function SQLGetData(
  HSTMT: lpVoid; iCol: word; fCType: smallInt;
  Var rgbValue; cbValueMax: longInt; Var pcbValue: longInt
): smallInt;
{ 44. }
Function SQLGetFunctions(HDBC: lpVoid; fFunction: word; Var pfExists: WordBool): smallInt;
{ 45. }
Function SQLGetInfo(
    HDBC: lpVoid; fInfoType: word;
    Var rgbInfoValue; cbInfoValueMax: smallInt; Var pcbInfoValue: smallInt
): smallInt;
{ 46. }
Function SQLGetStmtOption(HSTMT: lpVoid; fOption: word; Var pvParam: longInt): smallInt;
{ 47. }
Function SQLGetTypeInfo(HSTMT: lpVoid; fSqlType : smallInt): smallInt;
{ 48. }
Function SQLParamData(HSTMT: lpVoid; Var prgbValue: pointer): smallInt;
{ 49. }
Function SQLPutData(HSTMT: lpVoid; Var rgbValue; cbValue: longInt): smallInt;
{ 50. }
Function SQLSetConnectOption(HDBC: lpVoid; fOption: word; vParam: longInt): smallInt;
{ 51. }
Function SQLSetStmtOption(HSTMT: lpVoid; fOption: word; vParam: longInt): smallInt;
{ 52. }
Function SQLSpecialColumns(
  HSTMT: lpVoid; fColType: word;
  szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt;
  fScope: word; fNullable        : word
): smallInt;
{ 53. }
Function SQLStatistics(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt;
  fUnique: word; fAccuracy: word
): smallInt;
{ 54. }
Function SQLTables(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt;
  szTableType: PChar; cbTableType: smallInt
): smallInt;
{ LEVEL 2 FUNCTIONS }
{ 55. }
Function SQLBrowseConnect(
  HDBC: lpVoid; szConnStrIn: PChar; cbConnStrIn: smallInt;
  szConnStrOut: PChar; cbConnStrOutMax: smallInt; Var pcbConnStrOut: smallInt
): smallInt;
{ 56. }
Function SQLColumnPrivileges(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt;
  szColumnName: PChar; cbColumnName: smallInt
): smallInt;
{ 57. }
Function SQLDataSources(
  HENV: lpVoid; fDirection: word;
  szDSN: PChar; cbDSNMax: smallInt; Var pcbDSN: smallInt;
  szDescription: PChar; cbDescriptionMax: smallInt; Var pcbDescription: smallInt
): smallInt;
{ 58. }
Function SQLDescribeParam(
  HSTMT: lpVoid; iPar: word; Var pfSqlType: smallInt; Var pcbColDef: longInt;
  Var pibScale: smallInt; Var pfNullable: smallInt
): smallInt;
{ 59. }
Function SQLExtendedFetch(
  HSTMT: lpVoid; fFetchType: word; iRow: longInt; Var pcRow: longInt; Var rgfRowStatus: word
): smallInt;
{ 60. }
Function SQLForeignKeys(
  HSTMT: lpVoid; szPkTableQualifier: PChar; cbPkTableQualifier: smallInt;
  szPkTableOwner: PChar; cbPkTableOwner: smallInt; szPkTableName: PChar; cbPkTableName: smallInt;
  szFkTableQualifier: PChar; cbFkTableQualifier: smallInt;
  szFkTableOwner: PChar; cbFkTableOwner: smallInt; szFkTableName: PChar; cbFkTableName: smallInt
): smallInt;
{ 61. }
Function SQLMoreResults(HSTMT: lpVoid): smallInt;
{ 62. }
Function SQLNativeSql(
  HDBC: lpVoid; szSqlStrIn: PChar; cbSqlStrIn: longInt;
  szSqlStr: PChar; cbSqlStrMax: longInt; Var pcbSqlStr: longInt
): smallInt;
{ 63. }
Function SQLNumParams(HSTMT: lpVoid; Var pcPar : smallInt): smallInt;
{ 64. }
Function SQLParamOptions(HSTMT: lpVoid; cRow: longInt; Var piRow: longInt): smallInt;
{ 65. }
Function SQLPrimaryKeys(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt
): smallInt;
{ 66. }
Function SQLProcedureColumns(
  HSTMT: lpVoid; szProcQualifier: PChar; cbProcQualifier: smallInt;
  szProcOwner: PChar; cbProcOwner: smallInt; szProcName: PChar; cbProcName: smallInt;
  szColumnName: PChar; cbColumnName: smallInt
): smallInt;
{ 67. }
Function SQLProcedures(
  HSTMT: lpVoid; szProcQualifier: PChar; cbProcQualifier: smallInt;
  szProcOwner: PChar; cbProcOwner: smallInt; szProcName: PChar; cbProcName: smallInt
): smallInt;
{ 68. }
Function SQLSetPos(HSTMT: lpVoid; iRow: word; fOption: word; fLock: word): smallInt;
{ 69. -> SQLSetStmtOptions --> 51. }
Function SQLSetScrollOptions(
  HSTMT: lpVoid; fConcurrency: word; crowKeyset: longInt; crowRowset: word
): smallInt;
{ 70. }
Function SQLTablePrivileges(
  HSTMT: lpVoid; szTableQualifier: PChar; cbTableQualifier: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt; szTableName: PChar; cbTableName: smallInt
): smallInt;
{ SDK 2.0 ADDITIONS }
{ 71. }
Function SQLDrivers(
  HENV: lpVoid; fDirection: word;
  szDriverDesc: PChar; cbDriverDescMax: smallInt; Var pcbDriverDesc: smallInt;
  szDriverAttributes: PChar; cbDrvrAttrMax: smallInt; Var pcbDrvrAttr: smallInt
): smallInt;
{ 72. }
Function SQLBindParameter(
  HSTMT: lpVoid; iPar: word; fParamType: smallInt; fCType: smallInt;
  fSqlType: smallInt; cbColDef: longInt; ibScale: smallInt;
  Var rgbValue; cbValueMax: longInt; Var pcbValue: longInt
): smallInt;
{ EXTRA FUNCTIONS !!! not exist in general ODBC driver !!! }
{ 73. }
Function SQLOpenTable(
  HSTMT: lpVoid; szTableName: PChar; cbTableName: smallInt;
  szTableOwner: PChar; cbTableOwner: smallInt
): smallInt;
{ LEVEL 3 FUNCTIONS }
{ 1016. }
Function SQLSetConnectAttr(HDBC: lpVoid; Attribute: longInt; szValue: integer; cbValue: longInt): smallInt;
{ 1019. }
Function SQLSetEnvAttr(HENV: lpVoid; Attribute: longInt; szValue: integer; cbValue: longInt): smallInt;
{----------------------O D B C  F u n c t i o n s---------------------------}
{ -1 }
Procedure UnloadODBC_DLL;
{ -2 }
Function LoadODBC_DLL(DLLName: PChar): boolean;
{ -3 }
Function SQL_OK(ErrC: smallInt; Pure: boolean): boolean;
{ -4 }
Function Get_SQL_API_FN_Idx(SQL_API_C: smallInt): byte;
{ -5 }
Procedure GetSQL_hDBC_Functions(hDBC: lpVoid; var hDBCfn: TSQL_IMPLEMENTED_FUNCTIONS);
{ -6 }
Procedure SQLErrorProcess(hENV: lpVoid; hDBC: lpVoid; hSTMT: lpVoid; EMsg: PChar = NIL; ELen: word = 0);
{------------------------------------------------------------------------------------------------------}

implementation

uses
  SysUtils, ODBCDebug;

var
  { HANDLE of 'ODBC32.DLL' or 'libodbc.so' }
  ODBC_hDLL: HMODULE = HMODULE(0);
  { --- CORE FUNCTIONS --- }
  {    1. } _SQLAllocConnect: TSQLAllocConnect = NIL;
  {    2. } _SQLAllocEnv: TSQLAllocEnv = NIL;
  {    3. } _SQLAllocStmt: TSQLAllocStmt = NIL;
  {    4. } _SQLBindCol: TSQLBindCol = NIL;
  {    5. } _SQLCancel: TSQLCancel = NIL;
  {    6. } _SQLColAttributes: TSQLColAttributes = NIL;
  {    7. } _SQLConnect: TSQLConnect = NIL;
  {    8. } _SQLDescribeCol: TSQLDescribeCol = NIL;
  {    9. } _SQLDisconnect: TSQLDisconnect = NIL;
  {   10. } _SQLError: TSQLError = NIL;
  {   11. } _SQLExecDirect: TSQLExecDirect = NIL;
  {   12. } _SQLExecute: TSQLExecute = NIL;
  {   13. } _SQLFetch: TSQLFetch = NIL;
  {   14. } _SQLFreeConnect: TSQLFreeConnect = NIL;
  {   15. } _SQLFreeEnv: TSQLFreeEnv = NIL;
  {   16. } _SQLFreeStmt: TSQLFreeStmt = NIL;
  {   17. } _SQLGetCursorName: TSQLGetCursorName = NIL;
  {   18. } _SQLNumResultCols: TSQLNumResultCols = NIL;
  {   19. } _SQLPrepare: TSQLPrepare = NIL;
  {   20. } _SQLRowCount: TSQLRowCount = NIL;
  {   21. } _SQLSetCursorName: TSQLSetCursorName = NIL;
  {   22. } _SQLSetParam: TSQLSetParam = NIL;
  {   23. } _SQLTransact: TSQLTransact = NIL;
  { -- LEVEL 1 FUNCTIONS --- }
  {   40. } _SQLColumns: TSQLColumns = NIL;
  {   41. } _SQLDriverConnect: TSQLDriverConnect = NIL;
  {   42. } _SQLGetConnectOption: TSQLGetConnectOption = NIL;
  {   43. } _SQLGetData: TSQLGetData = NIL;
  {   44. } _SQLGetFunctions: TSQLGetFunctions = NIL;
  {   45. } _SQLGetInfo: TSQLGetInfo = NIL;
  {   46. } _SQLGetStmtOption: TSQLGetStmtOption = NIL;
  {   47. } _SQLGetTypeInfo: TSQLGetTypeInfo = NIL;
  {   48. } _SQLParamData: TSQLParamData = NIL;
  {   49. } _SQLPutData: TSQLPutData = NIL;
  {   50. } _SQLSetConnectOption: TSQLSetConnectOption = NIL;
  {   51. } _SQLSetStmtOption: TSQLSetStmtOption = NIL;
  {   52. } _SQLSpecialColumns: TSQLSpecialColumns = NIL;
  {   53. } _SQLStatistics: TSQLStatistics = NIL;
  {   54. } _SQLTables: TSQLTables = NIL;
  { --- LEVEL 2 FUNCTIONS --- }
  {   55. } _SQLBrowseConnect: TSQLBrowseConnect = NIL;
  {   56. } _SQLColumnPrivileges: TSQLColumnPrivileges = NIL;
  {   57. } _SQLDataSources: TSQLDataSources = NIL;
  {   58. } _SQLDescribeParam: TSQLDescribeParam = NIL;
  {   59. } _SQLExtendedFetch: TSQLExtendedFetch = NIL;
  {   60. } _SQLForeignKeys: TSQLForeignKeys = NIL;
  {   61. } _SQLMoreResults: TSQLMoreResults = NIL;
  {   62. } _SQLNativeSql: TSQLNativeSql = NIL;
  {   63. } _SQLNumParams: TSQLNumParams = NIL;
  {   64. } _SQLParamOptions: TSQLParamOptions = NIL;
  {   65. } _SQLPrimaryKeys: TSQLPrimaryKeys = NIL;
  {   66. } _SQLProcedureColumns: TSQLProcedureColumns = NIL;
  {   67. } _SQLProcedures: TSQLProcedures = NIL;
  {   68. } _SQLSetPos: TSQLSetPos = NIL;
  {   69. } _SQLSetScrollOptions: TSQLSetScrollOptions = NIL;
  {   70. } _SQLTablePrivileges: TSQLTablePrivileges = NIL;
  { --- SDK 2.0 ADDITIONS --- }
  {   71. } _SQLDrivers: TSQLDrivers = NIL;
  {   72. } _SQLBindParameter: TSQLBindParameter = NIL;
  {   73. } _SQLOpenTable: TSQLOpenTable = NIL;
  { --- LEVEL 3 FUNCTIONS --- }
  { 1016. } _SQLSetConnectAttr: TSQLSetConnectAttr = NIL;
  { 1019. } _SQLSetEnvAttr: TSQLSetEnvAttr = NIL;

ThreadVar
  ODBC_LAST_ERROR_CODE: longInt;
  ODBC_LAST_FN_NAME: String[32];

{
  SysUtils.FreeLibrary --> Libc.dlclose
}
procedure UnloadODBC_DLL;
var
  I: smallInt;
begin
  for I:= 0 to SQL_EXT_API_END do begin
    SQL_IMPLEMENTED_FUNCTIONS[I]:= FALSE;
    SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= 0;
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[I]:= NIL;
  end;
  { --- CORE FUNCTIONS --- }
  {    1. } _SQLAllocConnect:= NIL;
  {    2. } _SQLAllocEnv:= NIL;
  {    3. } _SQLAllocStmt:= NIL;
  {    4. } _SQLBindCol:= NIL;
  {    5. } _SQLCancel:= NIL;
  {    6. } _SQLColAttributes:= NIL;
  {    7. } _SQLConnect:= NIL;
  {    8. } _SQLDescribeCol:= NIL;
  {    9. } _SQLDisconnect:= NIL;
  {   10. } _SQLError:= NIL;
  {   11. } _SQLExecDirect:= NIL;
  {   12. } _SQLExecute:= NIL;
  {   13. } _SQLFetch:= NIL;
  {   14. } _SQLFreeConnect:= NIL;
  {   15. } _SQLFreeEnv:= NIL;
  {   16. } _SQLFreeStmt:= NIL;
  {   17. } _SQLGetCursorName:= NIL;
  {   18. } _SQLNumResultCols:= NIL;
  {   19. } _SQLPrepare:= NIL;
  {   20. } _SQLRowCount:= NIL;
  {   21. } _SQLSetCursorName:= NIL;
  {   22. } _SQLSetParam:= NIL;
  {   23. } _SQLTransact:= NIL;
  { -- LEVEL 1 FUNCTIONS --- }
  {   40. } _SQLColumns:= NIL;
  {   41. } _SQLDriverConnect:= NIL;
  {   42. } _SQLGetConnectOption:= NIL;
  {   43. } _SQLGetData:= NIL;
  {   44. } _SQLGetFunctions:= NIL;
  {   45. } _SQLGetInfo:= NIL;
  {   46. } _SQLGetStmtOption:= NIL;
  {   47. } _SQLGetTypeInfo:= NIL;
  {   48. } _SQLParamData:= NIL;
  {   49. } _SQLPutData:= NIL;
  {   50. } _SQLSetConnectOption:= NIL;
  {   51. } _SQLSetStmtOption:= NIL;
  {   52. } _SQLSpecialColumns:= NIL;
  {   53. } _SQLStatistics:= NIL;
  {   54. } _SQLTables:= NIL;
  { --- LEVEL 2 FUNCTIONS --- }
  {   55. } _SQLBrowseConnect:= NIL;
  {   56. } _SQLColumnPrivileges:= NIL;
  {   57. } _SQLDataSources:= NIL;
  {   58. } _SQLDescribeParam:= NIL;
  {   59. } _SQLExtendedFetch:= NIL;
  {   60. } _SQLForeignKeys:= NIL;
  {   61. } _SQLMoreResults:= NIL;
  {   62. } _SQLNativeSql:= NIL;
  {   63. } _SQLNumParams:= NIL;
  {   64. } _SQLParamOptions:= NIL;
  {   65. } _SQLPrimaryKeys:= NIL;
  {   66. } _SQLProcedureColumns:= NIL;
  {   67. } _SQLProcedures:= NIL;
  {   68. } _SQLSetPos:= NIL;
  {   69. } _SQLSetScrollOptions:= NIL;
  {   70. } _SQLTablePrivileges:= NIL;
  { --- SDK 2.0 ADDITIONS --- }
  {   71. } _SQLDrivers:= NIL;
  {   72. } _SQLBindParameter:= NIL;
  {   73. } _SQLOpenTable:= NIL;
  { --- LEVEL 3 FUNCTIONS --- }
  { 1016. } _SQLSetConnectAttr:= NIL;
  { 1019. } _SQLSetEnvAttr:= NIL;
  if NOT (ODBC_hDLL = HMODULE(0)) then begin
    FreeLibrary(ODBC_hDLL);
    ODBC_hDLL:= HMODULE(0);
  end;
end;

{
  SysUtils.LoadLibrary --> Libc.dlopen
  SysUtils.GetProcAddress --> Libc.dlsym
}
function LoadODBC_DLL(DLLName: PChar): boolean;
var
  I: smallInt;
begin
  Result:= False;

  UnloadODBC_DLL;

  if Assigned(DLLName) AND (StrLen(DLLName)>0) then begin
    ODBC_hDLL:= LoadLibrary(DLLName);
  end else begin
    ODBC_hDLL:= LoadLibrary(ODBC_DLL);
  end;
  if NOT (ODBC_hDLL = HMODULE(0)) then begin
    for I:= 1 to SQL_NUM_FUNCTIONS do begin
      SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= I;
    end;
    for I:= SQL_EXT_API_START to SQL_EXT_API_LAST do begin
      SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= I;
    end;
    for I:= SQL_EXT_API_BEGIN to SQL_EXT_API_END do begin
      case I of
        SQL_API_OPENTABLE: SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= I;
        SQL_API_OPENTABLE+1: SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= SQL_API_SQLSETCONNECTATTR;
        SQL_API_OPENTABLE+2: SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= SQL_API_SQLSETENVATTR;
      end;
    end;

    { --- CORE FUNCTIONS --- }
    {    1. } _SQLAllocConnect:= GetProcAddress(ODBC_hDLL, 'SQLAllocConnect');
    {    2. } _SQLAllocEnv:= GetProcAddress(ODBC_hDLL, 'SQLAllocEnv');
    {    3. } _SQLAllocStmt:= GetProcAddress(ODBC_hDLL, 'SQLAllocStmt');
    {    4. } _SQLBindCol:= GetProcAddress(ODBC_hDLL, 'SQLBindCol');
    {    5. } _SQLCancel:= GetProcAddress(ODBC_hDLL, 'SQLCancel');
    {    6. } _SQLColAttributes:= GetProcAddress(ODBC_hDLL, 'SQLColAttributes');
    {    7. } _SQLConnect:= GetProcAddress(ODBC_hDLL, 'SQLConnect');
    {    8. } _SQLDescribeCol:= GetProcAddress(ODBC_hDLL, 'SQLDescribeCol');
    {    9. } _SQLDisconnect:= GetProcAddress(ODBC_hDLL, 'SQLDisconnect');
    {   10. } _SQLError:= GetProcAddress(ODBC_hDLL, 'SQLError');
    {   11. } _SQLExecDirect:= GetProcAddress(ODBC_hDLL, 'SQLExecDirect');
    {   12. } _SQLExecute:= GetProcAddress(ODBC_hDLL, 'SQLExecute');
    {   13. } _SQLFetch:= GetProcAddress(ODBC_hDLL, 'SQLFetch');
    {   14. } _SQLFreeConnect:= GetProcAddress(ODBC_hDLL, 'SQLFreeConnect');
    {   15. } _SQLFreeEnv:= GetProcAddress(ODBC_hDLL, 'SQLFreeEnv');
    {   16. } _SQLFreeStmt:= GetProcAddress(ODBC_hDLL, 'SQLFreeStmt');
    {   17. } _SQLGetCursorName:= GetProcAddress(ODBC_hDLL, 'SQLGetCursorName');
    {   18. } _SQLNumResultCols:= GetProcAddress(ODBC_hDLL, 'SQLNumResultCols');
    {   19. } _SQLPrepare:= GetProcAddress(ODBC_hDLL, 'SQLPrepare');
    {   20. } _SQLRowCount:= GetProcAddress(ODBC_hDLL, 'SQLRowCount');
    {   21. } _SQLSetCursorName:= GetProcAddress(ODBC_hDLL, 'SQLSetCursorName');
    {   22. } _SQLSetParam:= GetProcAddress(ODBC_hDLL, 'SQLSetParam');
    {   23. } _SQLTransact:= GetProcAddress(ODBC_hDLL, 'SQLTransact');
    { -- LEVEL 1 FUNCTIONS --- }
    {   40. } _SQLColumns:= GetProcAddress(ODBC_hDLL, 'SQLColumns');
    {   41. } _SQLDriverConnect:= GetProcAddress(ODBC_hDLL, 'SQLDriverConnect');
    {   42. } _SQLGetConnectOption:= GetProcAddress(ODBC_hDLL, 'SQLGetConnectOption');
    {   43. } _SQLGetData:= GetProcAddress(ODBC_hDLL, 'SQLGetData');
    {   44. } _SQLGetFunctions:= GetProcAddress(ODBC_hDLL, 'SQLGetFunctions');
    {   45. } _SQLGetInfo:= GetProcAddress(ODBC_hDLL, 'SQLGetInfo');
    {   46. } _SQLGetStmtOption:= GetProcAddress(ODBC_hDLL, 'SQLGetStmtOption');
    {   47. } _SQLGetTypeInfo:= GetProcAddress(ODBC_hDLL, 'SQLGetTypeInfo');
    {   48. } _SQLParamData:= GetProcAddress(ODBC_hDLL, 'SQLParamData');
    {   49. } _SQLPutData:= GetProcAddress(ODBC_hDLL, 'SQLPutData');
    {   50. } _SQLSetConnectOption:= GetProcAddress(ODBC_hDLL, 'SQLSetConnectOption');
    {   51. } _SQLSetStmtOption:= GetProcAddress(ODBC_hDLL, 'SQLSetStmtOption');
    {   52. } _SQLSpecialColumns:= GetProcAddress(ODBC_hDLL, 'SQLSpecialColumns');
    {   53. } _SQLStatistics:= GetProcAddress(ODBC_hDLL, 'SQLStatistics');
    {   54. } _SQLTables:= GetProcAddress(ODBC_hDLL, 'SQLTables');
    { --- LEVEL 2 FUNCTIONS --- }
    {   55. } _SQLBrowseConnect:= GetProcAddress(ODBC_hDLL, 'SQLBrowseConnect');
    {   56. } _SQLColumnPrivileges:= GetProcAddress(ODBC_hDLL, 'SQLColumnPrivileges');
    {   57. } _SQLDataSources:= GetProcAddress(ODBC_hDLL, 'SQLDataSources');
    {   58. } _SQLDescribeParam:= GetProcAddress(ODBC_hDLL, 'SQLDescribeParam');
    {   59. } _SQLExtendedFetch:= GetProcAddress(ODBC_hDLL, 'SQLExtendedFetch');
    {   60. } _SQLForeignKeys:= GetProcAddress(ODBC_hDLL, 'SQLForeignKeys');
    {   61. } _SQLMoreResults:= GetProcAddress(ODBC_hDLL, 'SQLMoreResults');
    {   62. } _SQLNativeSql:= GetProcAddress(ODBC_hDLL, 'SQLNativeSql');
    {   63. } _SQLNumParams:= GetProcAddress(ODBC_hDLL, 'SQLNumParams');
    {   64. } _SQLParamOptions:= GetProcAddress(ODBC_hDLL, 'SQLParamOptions');
    {   65. } _SQLPrimaryKeys:= GetProcAddress(ODBC_hDLL, 'SQLPrimaryKeys');
    {   66. } _SQLProcedureColumns:= GetProcAddress(ODBC_hDLL, 'SQLProcedureColumns');
    {   67. } _SQLProcedures:= GetProcAddress(ODBC_hDLL, 'SQLProcedures');
    {   68. } _SQLSetPos:= GetProcAddress(ODBC_hDLL, 'SQLSetPos');
    {   69. } _SQLSetScrollOptions:= GetProcAddress(ODBC_hDLL, 'SQLSetScrollOptions');
    {   70. } _SQLTablePrivileges:= GetProcAddress(ODBC_hDLL, 'SQLTablePrivileges');
    { --- SDK 2.0 ADDITIONS --- }
    {   71. } _SQLDrivers:= GetProcAddress(ODBC_hDLL, 'SQLDrivers');
    {   72. } _SQLBindParameter:= GetProcAddress(ODBC_hDLL, 'SQLBindParameter');
    {   73. } _SQLOpenTable:= GetProcAddress(ODBC_hDLL, 'SQLOpenTable');
    { --- LEVEL 3 FUNCTIONS --- }
    { 1019. } _SQLSetEnvAttr:= GetProcAddress(ODBC_hDLL, 'SQLSetEnvAttr');
    { 1016. } _SQLSetConnectAttr:= GetProcAddress(ODBC_hDLL, 'SQLSetConnectAttr');


    { --- CORE FUNCTIONS --- }
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    1]:= Pointer(@_SQLAllocConnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    2]:= Pointer(@_SQLAllocEnv);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    3]:= Pointer(@_SQLAllocStmt);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    4]:= Pointer(@_SQLBindCol);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    5]:= Pointer(@_SQLCancel);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    6]:= Pointer(@_SQLColAttributes);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    7]:= Pointer(@_SQLConnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    8]:= Pointer(@_SQLDescribeCol);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[    9]:= Pointer(@_SQLDisconnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   10]:= Pointer(@_SQLError);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   11]:= Pointer(@_SQLExecDirect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   12]:= Pointer(@_SQLExecute);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   13]:= Pointer(@_SQLFetch);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   14]:= Pointer(@_SQLFreeConnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   15]:= Pointer(@_SQLFreeEnv);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   16]:= Pointer(@_SQLFreeStmt);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   17]:= Pointer(@_SQLGetCursorName);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   18]:= Pointer(@_SQLNumResultCols);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   19]:= Pointer(@_SQLPrepare);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   20]:= Pointer(@_SQLRowCount);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   21]:= Pointer(@_SQLSetCursorName);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   22]:= Pointer(@_SQLSetParam);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   23]:= Pointer(@_SQLTransact);
    { -- LEVEL 1 FUNCTIONS --- }
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   40]:= Pointer(@_SQLColumns);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   41]:= Pointer(@_SQLDriverConnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   42]:= Pointer(@_SQLGetConnectOption);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   43]:= Pointer(@_SQLGetData);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   44]:= Pointer(@_SQLGetFunctions);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   45]:= Pointer(@_SQLGetInfo);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   46]:= Pointer(@_SQLGetStmtOption);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   47]:= Pointer(@_SQLGetTypeInfo);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   48]:= Pointer(@_SQLParamData);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   49]:= Pointer(@_SQLPutData);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   50]:= Pointer(@_SQLSetConnectOption);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   51]:= Pointer(@_SQLSetStmtOption);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   52]:= Pointer(@_SQLSpecialColumns);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   53]:= Pointer(@_SQLStatistics);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   54]:= Pointer(@_SQLTables);
    { --- LEVEL 2 FUNCTIONS --- }
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   55]:= Pointer(@_SQLBrowseConnect);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   56]:= Pointer(@_SQLColumnPrivileges);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   57]:= Pointer(@_SQLDataSources);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   58]:= Pointer(@_SQLDescribeParam);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   59]:= Pointer(@_SQLExtendedFetch);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   60]:= Pointer(@_SQLForeignKeys);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   61]:= Pointer(@_SQLMoreResults);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   62]:= Pointer(@_SQLNativeSql);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   63]:= Pointer(@_SQLNumParams);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   64]:= Pointer(@_SQLParamOptions);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   65]:= Pointer(@_SQLPrimaryKeys);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   66]:= Pointer(@_SQLProcedureColumns);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   67]:= Pointer(@_SQLProcedures);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   68]:= Pointer(@_SQLSetPos);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   69]:= Pointer(@_SQLSetScrollOptions);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   70]:= Pointer(@_SQLTablePrivileges);
    { --- SDK 2.0 ADDITIONS --- }
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   71]:= Pointer(@_SQLDrivers);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   72]:= Pointer(@_SQLBindParameter);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   73]:= Pointer(@_SQLOpenTable);
    { --- LEVEL 3 FUNCTIONS --- }
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   74]:= Pointer(@_SQLSetEnvAttr);
    SQL_IMPLEMENTED_FUNCTIONS_ADDR[   75]:= Pointer(@_SQLSetConnectAttr);
    {  }
    for I:= 0 to SQL_EXT_API_END do begin
      if SQL_IMPLEMENTED_FUNCTIONS_ADDR[I] = NIL then begin
        SQL_IMPLEMENTED_FUNCTIONS[I]:= FALSE;
        SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I]:= 0;
      end else begin
        SQL_IMPLEMENTED_FUNCTIONS[I]:= TRUE;
        Result:= True;
      end;
    end;
    if NOT Result then begin
      UnloadODBC_DLL;
    end;
  end;
end;

{  1. }
Function SQLAllocConnect; {EXTERNAL ODBC_DLL NAME 'SQLAllocConnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLAllocConnect';
  if Assigned(_SQLAllocConnect) then begin
    Result:= _SQLAllocConnect(HENV, HDBC);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  2. }
Function SQLAllocEnv; {EXTERNAL ODBC_DLL NAME 'SQLAllocEnv';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLAllocEnv';
  if Assigned(_SQLAllocEnv) then begin
    Result:= _SQLAllocEnv(HENV);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  3. }
Function SQLAllocStmt; {EXTERNAL ODBC_DLL NAME 'SQLAllocStmt';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLAllocStmt';
  if Assigned(_SQLAllocStmt) then begin
    Result:= _SQLAllocStmt(HDBC, HSTMT);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  4. }
Function SQLBindCol; {EXTERNAL ODBC_DLL NAME 'SQLBindCol';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLBindCol';
  if Assigned(_SQLBindCol) then begin
    Result:= _SQLBindCol(HSTMT, iCol, fCType, rgbValue, cbValueMax, pcbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  5. }
Function SQLCancel; {EXTERNAL ODBC_DLL NAME 'SQLCancel';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLCancel';
  if Assigned(_SQLCancel) then begin
    Result:= _SQLCancel(HSTMT);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  6. }
Function SQLColAttributes; {EXTERNAL ODBC_DLL NAME 'SQLColAttributes';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLColAttributes';
  if Assigned(_SQLColAttributes) then begin
    Result:= _SQLColAttributes(HSTMT, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  7. }
Function SQLConnect; {EXTERNAL ODBC_DLL NAME 'SQLConnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLConnect';
  if Assigned(_SQLConnect) then begin
    Result:= _SQLConnect(HDBC, szDSN, cbDSN, szUID, cbUID, szPWD, cbPWD);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  8. }
Function SQLDescribeCol; {EXTERNAL ODBC_DLL NAME 'SQLDescribeCol';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDescribeCol';
  if Assigned(_SQLDescribeCol) then begin
    Result:= _SQLDescribeCol(HSTMT, icol, szColName, cbColNameMax, pcbColName, pfSqlType, pcbColDef, pibScale, pfNullable);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{  9. }
Function SQLDisconnect; {EXTERNAL ODBC_DLL NAME 'SQLDisconnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDisconnect';
  if Assigned(_SQLDisconnect) then begin
    Result:= _SQLDisconnect(HDBC);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 10. }
Function SQLError; {EXTERNAL ODBC_DLL NAME 'SQLError';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLError';
  if Assigned(_SQLError) then begin
    Result:= _SQLError(HENV, HDBC, HSTMT, szSQLState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 11. }
Function SQLExecDirect; {EXTERNAL ODBC_DLL NAME 'SQLExecDirect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLExecDirect';
  if Assigned(_SQLExecDirect) then begin
    Result:= _SQLExecDirect(HSTMT, szSqlStr, cbSqlStr);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 12. }
Function SQLExecute; {EXTERNAL ODBC_DLL NAME 'SQLExecute';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLExecute';
  if Assigned(_SQLExecute) then begin
    Result:= _SQLExecute(HSTMT);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 13. }
Function SQLFetch; {EXTERNAL ODBC_DLL NAME 'SQLFetch';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLFetch';
  if Assigned(_SQLFetch) then begin
    Result:= _SQLFetch(HSTMT);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 14. }
Function SQLFreeConnect; {EXTERNAL ODBC_DLL NAME 'SQLFreeConnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLFreeConnect';
  if Assigned(_SQLFreeConnect) then begin
    Result:= _SQLFreeConnect(HDBC);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 15. }
Function SQLFreeEnv; {EXTERNAL ODBC_DLL NAME 'SQLFreeEnv';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLFreeEnv';
  if Assigned(_SQLFreeEnv) then begin
    Result:= _SQLFreeEnv(HENV);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 16. }
Function SQLFreeStmt; {EXTERNAL ODBC_DLL NAME 'SQLFreeStmt';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLFreeStmt';
  if Assigned(_SQLFreeStmt) then begin
    Result:= _SQLFreeStmt(HSTMT, fOption);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 17. }
Function SQLGetCursorName; {EXTERNAL ODBC_DLL NAME 'SQLGetCursorName';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetCursorName';
  if Assigned(_SQLGetCursorName) then begin
    Result:= _SQLGetCursorName(HSTMT, szCursor, cbCursorMax, pcbCursor);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 18. }
Function SQLNumResultCols; {EXTERNAL ODBC_DLL NAME 'SQLNumResultCols';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLNumResultCols';
  if Assigned(_SQLNumResultCols) then begin
    Result:= _SQLNumResultCols(HSTMT, nCOL);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 19. }
Function SQLPrepare; {EXTERNAL ODBC_DLL NAME 'SQLPrepare';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLPrepare';
  if Assigned(_SQLPrepare) then begin
    Result:= _SQLPrepare(HSTMT, szSQLStr, cbSQLStr);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 20. }
Function SQLRowCount; {EXTERNAL ODBC_DLL NAME 'SQLRowCount';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLRowCount';
  if Assigned(_SQLRowCount) then begin
    Result:= _SQLRowCount(HSTMT, nROW);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 21. }
Function SQLSetCursorName; {EXTERNAL ODBC_DLL NAME 'SQLSetCursorName';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetCursorName';
  if Assigned(_SQLSetCursorName) then begin
    Result:= _SQLSetCursorName(HSTMT, szCursor, cbCursor);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 22. -> SQLBindParameter --> 72. }
Function SQLSetParam; {EXTERNAL ODBC_DLL NAME 'SQLSetParam';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetParam';
  if Assigned(_SQLSetParam) then begin
    Result:= _SQLSetParam(HSTMT, ipar, fCType, fSqlType, cbColDef, ibScale, rgbValue, pcbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 23. }
Function SQLTransact; {EXTERNAL ODBC_DLL NAME 'SQLTransact';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= '';
  if Assigned(_SQLTransact) then begin
    Result:= _SQLTransact(HENV, HDBC, fType);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ LEVEL 1 FUNCTIONS }
{ 40. }
Function SQLColumns; {EXTERNAL ODBC_DLL NAME 'SQLColumns';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLColumns';
  if Assigned(_SQLColumns) then begin
    Result:= _SQLColumns(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName, szColumnName, cbColumnName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 41. }
Function SQLDriverConnect; {EXTERNAL ODBC_DLL NAME 'SQLDriverConnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDriverConnect';
  if Assigned(_SQLDriverConnect) then begin
    Result:= _SQLDriverConnect(HDBC, HWND_SQL, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, fDriverCompletion);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 42. }
Function SQLGetConnectOption; {EXTERNAL ODBC_DLL NAME 'SQLGetConnectOption';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetConnectOption';
  if Assigned(_SQLGetConnectOption) then begin
    Result:= _SQLGetConnectOption(HDBC, fOption, vParam);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 43. }
Function SQLGetData; {EXTERNAL ODBC_DLL NAME 'SQLGetData';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetData';
  if Assigned(_SQLGetData) then begin
    Result:= _SQLGetData(HSTMT, icol, fCType, rgbValue, cbValueMax, pcbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 44. }
Function SQLGetFunctions; {EXTERNAL ODBC_DLL NAME 'SQLGetFunctions';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetFunctions';
  if Assigned(_SQLGetFunctions) then begin
    Result:= _SQLGetFunctions(HDBC, fFunction, pfExists);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 45. }
Function SQLGetInfo; {EXTERNAL ODBC_DLL NAME 'SQLGetInfo';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetInfo';
  if Assigned(_SQLGetInfo) then begin
    Result:= _SQLGetInfo(HDBC, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 46. }
Function SQLGetStmtOption; {EXTERNAL ODBC_DLL NAME 'SQLGetStmtOption';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetStmtOption';
  if Assigned(_SQLGetStmtOption) then begin
    Result:= _SQLGetStmtOption(HSTMT, fOption, pvParam);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 47. }
Function SQLGetTypeInfo; {EXTERNAL ODBC_DLL NAME 'SQLGetTypeInfo';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLGetTypeInfo';
  if Assigned(_SQLGetTypeInfo) then begin
    Result:= _SQLGetTypeInfo(HSTMT, fSqlType);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 48. }
Function SQLParamData; {EXTERNAL ODBC_DLL NAME 'SQLParamData';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLParamData';
  if Assigned(_SQLParamData) then begin
    Result:= _SQLParamData(HSTMT, prgbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 49. }
Function SQLPutData; {EXTERNAL ODBC_DLL NAME 'SQLPutData';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLPutData';
  if Assigned(_SQLPutData) then begin
    Result:= _SQLPutData(HSTMT, rgbValue, cbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 50. }
Function SQLSetConnectOption; {EXTERNAL ODBC_DLL NAME 'SQLSetConnectOption';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetConnectOption';
  if Assigned(_SQLSetConnectOption) then begin
    Result:= _SQLSetConnectOption(HDBC, fOption, vParam);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 51. }
Function SQLSetStmtOption; {EXTERNAL ODBC_DLL NAME 'SQLSetStmtOption';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetStmtOption';
  if Assigned(_SQLSetStmtOption) then begin
    Result:= _SQLSetStmtOption(HSTMT, fOption, vParam);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 52. }
Function SQLSpecialColumns; {EXTERNAL ODBC_DLL NAME 'SQLSpecialColumns';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSpecialColumns';
  if Assigned(_SQLSpecialColumns) then begin
    Result:= _SQLSpecialColumns(HSTMT, fColType, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName, fScope, fNullable);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 53. }
Function SQLStatistics; {EXTERNAL ODBC_DLL NAME 'SQLStatistics';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLStatistics';
  if Assigned(_SQLStatistics) then begin
    Result:= _SQLStatistics(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName, fUnique, fAccuracy);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 54. }
Function SQLTables; {EXTERNAL ODBC_DLL NAME 'SQLTables';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLTables';
  if Assigned(_SQLTables) then begin
    Result:= _SQLTables(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName, szTableType, cbTableType);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ LEVEL 2 FUNCTIONS }
{ 55. }
Function SQLBrowseConnect; {EXTERNAL ODBC_DLL NAME 'SQLBrowseConnect';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLBrowseConnect';
  if Assigned(_SQLBrowseConnect) then begin
    Result:= _SQLBrowseConnect(HDBC, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 56. }
Function SQLColumnPrivileges; {EXTERNAL ODBC_DLL NAME 'SQLColumnPrivileges';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLColumnPrivileges';
  if Assigned(_SQLColumnPrivileges) then begin
    Result:= _SQLColumnPrivileges(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName, szColumnName, cbColumnName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 57. }
Function SQLDataSources; {EXTERNAL ODBC_DLL NAME 'SQLDataSources';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDataSources';
  if Assigned(_SQLDataSources) then begin
    Result:= _SQLDataSources(HENV, fDirection, szDSN, cbDSNMax, pcbDSN, szDescription, cbDescriptionMax, pcbDescription);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 58. }
Function SQLDescribeParam; {EXTERNAL ODBC_DLL NAME 'SQLDescribeParam';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDescribeParam';
  if Assigned(_SQLDescribeParam) then begin
    Result:= _SQLDescribeParam(HSTMT, iPar, pfSqlType, pcbColDef, pibScale, pfNullable);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 59. }
Function SQLExtendedFetch; {EXTERNAL ODBC_DLL NAME 'SQLExtendedFetch';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLExtendedFetch';
  if Assigned(_SQLExtendedFetch) then begin
    Result:= _SQLExtendedFetch(HSTMT, fFetchType, iRow, pcRow, rgfRowStatus);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 60. }
Function SQLForeignKeys; {EXTERNAL ODBC_DLL NAME 'SQLForeignKeys';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLForeignKeys';
  if Assigned(_SQLForeignKeys) then begin
    Result:= _SQLForeignKeys(
      HSTMT,
      szPkTableQualifier, cbPkTableQualifier, szPkTableOwner, cbPkTableOwner, szPkTableName, cbPkTableName,
      szFkTableQualifier, cbFkTableQualifier, szFkTableOwner, cbFkTableOwner, szFkTableName, cbFkTableName
    );
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 61. }
Function SQLMoreResults; {EXTERNAL ODBC_DLL NAME 'SQLMoreResults';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLMoreResults';
  if Assigned(_SQLMoreResults) then begin
    Result:= _SQLMoreResults(HSTMT);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 62. }
Function SQLNativeSql; {EXTERNAL ODBC_DLL NAME 'SQLNativeSql';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLNativeSql';
  if Assigned(_SQLNativeSql) then begin
    Result:= _SQLNativeSql(HDBC, szSqlStrIn, cbSqlStrIn, szSqlStr, cbSqlStrMax, pcbSqlStr);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 63. }
Function SQLNumParams; {EXTERNAL ODBC_DLL NAME 'SQLNumParams';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLNumParams';
  if Assigned(_SQLNumParams) then begin
    Result:= _SQLNumParams(HSTMT, pcPar);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 64. }
Function SQLParamOptions; {EXTERNAL ODBC_DLL NAME 'SQLParamOptions';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLParamOptions';
  if Assigned(_SQLParamOptions) then begin
    Result:= _SQLParamOptions(HSTMT, cRow, piRow);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 65. }
Function SQLPrimaryKeys; {EXTERNAL ODBC_DLL NAME 'SQLPrimaryKeys';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLPrimaryKeys';
  if Assigned(_SQLPrimaryKeys) then begin
    Result:= _SQLPrimaryKeys(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 66. }
Function SQLProcedureColumns; {EXTERNAL ODBC_DLL NAME 'SQLProcedureColumns';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLProcedureColumns';
  if Assigned(_SQLProcedureColumns) then begin
    Result:= _SQLProcedureColumns(HSTMT, szProcQualifier, cbProcQualifier, szProcOwner, cbProcOwner, szProcName, cbProcName, szColumnName, cbColumnName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 67. }
Function SQLProcedures; {EXTERNAL ODBC_DLL NAME 'SQLProcedures';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLProcedures';
  if Assigned(_SQLProcedures) then begin
    Result:= _SQLProcedures(HSTMT, szProcQualifier, cbProcQualifier, szProcOwner, cbProcOwner, szProcName, cbProcName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 68. }
Function SQLSetPos; {EXTERNAL ODBC_DLL NAME 'SQLSetPos';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetPos';
  if Assigned(_SQLSetPos) then begin
    Result:= _SQLSetPos(HSTMT, iRow, fOption, fLock);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 69. -> SQLSetStmtOptions --> 51. }
Function SQLSetScrollOptions; {EXTERNAL ODBC_DLL NAME 'SQLSetScrollOptions';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetScrollOptions';
  if Assigned(_SQLSetScrollOptions) then begin
    Result:= _SQLSetScrollOptions(HSTMT, fConcurrency, crowKeyset, crowRowset);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 70. }
Function SQLTablePrivileges; {EXTERNAL ODBC_DLL NAME 'SQLTablePrivileges';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLTablePrivileges';
  if Assigned(_SQLTablePrivileges) then begin
    Result:= _SQLTablePrivileges(HSTMT, szTableQualifier, cbTableQualifier, szTableOwner, cbTableOwner, szTableName, cbTableName);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ SDK 2.0 ADDITIONS }
{ 71. }
Function SQLDrivers; {EXTERNAL ODBC_DLL NAME 'SQLDrivers';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLDrivers';
  if Assigned(_SQLDrivers) then begin
    Result:= _SQLDrivers(HENV, fDirection, szDriverDesc, cbDriverDescMax, pcbDriverDesc, szDriverAttributes, cbDrvrAttrMax, pcbDrvrAttr);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 72. }
Function SQLBindParameter; {EXTERNAL ODBC_DLL NAME 'SQLBindParameter';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLBindParameter';
  if Assigned(_SQLBindParameter) then begin
    Result:= _SQLBindParameter(HSTMT, iPar, fParamType, fCType, fSqlType, cbColDef, ibScale, rgbValue, cbValueMax, pcbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 73. }
Function SQLOpenTable; {EXTERNAL ODBC_DLL NAME 'SQLOpenTable';}
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLOpenTable';
  if Assigned(_SQLOpenTable) then begin
    Result:= _SQLOpenTable(HSTMT, szTableName, cbTableName, szTableOwner, cbTableOwner);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ LEVEL 3 FUNCTIONS }
{ 1016. }
Function SQLSetConnectAttr; {EXTERNAL ODBC_DLL NAME 'SQLSetConnectAttr';}
var
  iValue: integer;
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetConnectAttr';
  if Assigned(_SQLSetConnectAttr) then begin
    iValue:= szValue;
    Result:= _SQLSetConnectAttr(HDBC, Attribute, iValue, cbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ 1019. }
Function SQLSetEnvAttr; {EXTERNAL ODBC_DLL NAME 'SQLSetEnvAttr';}
var
  iValue: integer;
begin
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= 'SQLSetEnvAttr';
  if Assigned(_SQLSetEnvAttr) then begin
    iValue:= szValue;
    Result:= _SQLSetEnvAttr(HENV, Attribute, iValue, cbValue);
  end else begin
    ODBC_LAST_ERROR_CODE:= -1;
    Result:= SQL_ERROR;
  end;
end;
{ -3 }
Function SQL_OK(ErrC: smallInt; Pure: boolean): boolean;
begin
  If Pure then begin
    Result:= ErrC = SQL_SUCCESS;
  end else begin
    Result:= (ErrC = SQL_SUCCESS) OR (ErrC = SQL_SUCCESS_WITH_INFO);
  end;
end;
{ -4 }
Function Get_SQL_API_FN_Idx(SQL_API_C: smallInt): byte;
var
  I: integer;
begin
  Result:= 0;
  for I:= 1 to SQL_EXT_API_END do begin
    If SQL_API_C = SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I] then begin
      Result:= I;
      BREAK;
    end;
  end;
end;
{ -5 }
Procedure GetSQL_hDBC_Functions(hDBC: lpVoid; var hDBCfn: TSQL_IMPLEMENTED_FUNCTIONS);
var
  I: smallInt;
  bSQLReceiveVar: wordBool;
begin
  for I:= 0 to SQL_EXT_API_END do begin
    hDBCfn[I]:= False;
    if SQL_IMPLEMENTED_FUNCTIONS[SQL_API_SQLGETFUNCTIONS] and SQL_IMPLEMENTED_FUNCTIONS[I] then begin
      if SQL_OK(SQLGetFunctions(hDBC, SQL_IMPLEMENTED_FUNCTIONS_API_CODES[I], bSQLReceiveVar), FALSE) then begin
        hDBCfn[I]:= bSQLReceiveVar;
      end;
    end;
  end;
end;
{ -6 }
Procedure SQLErrorProcess(hENV: lpVoid; hDBC: lpVoid; hSTMT: lpVoid; EMsg: PChar = NIL; ELen: word = 0);
const
  iSQLErrorMsgLenMax = smallInt(SQL_MAX_MESSAGE_LENGTH);
var
  SQLErrorState: packed array [0..SQL_SQLSTATE_SIZE] of char;
  lSQLNativeError: longInt;
  SQLNativeMsg: packed array [0..32] of char;
  SQLErrorMsg: packed array [0..SQL_MAX_MESSAGE_LENGTH] of char;
  iSQLErrorMsgLen: smallInt;
  szSQLErrorMsg: packed array [0..4096] of char;
begin
  szSQLErrorMsg[0]:=#0;
  if ODBC_LAST_ERROR_CODE = 0 then begin
    While
      SQL_OK(
        SQLError(
          hENV, hDBC, hSTMT,
          @SQLErrorState[0], lSQLNativeError,
          @SQLErrorMsg[0], iSQLErrorMsgLenMax, iSQLErrorMsgLen
        ),
        FALSE
      ) {$IFNDEF LINUX} OR (iSQLErrorMsgLen <> 0){$ENDIF}
    do begin
      SQLErrorMsg[iSQLErrorMsgLen]:= #0;
      StrCopy(@SQLNativeMsg[0], '(');
      StrPCopy(@SQLNativeMsg[1], IntToStr(lSQLNativeError));
      StrCat(@SQLNativeMsg[0], ')');

      StrCat(@szSQLErrorMsg[0], @SQLErrorState[0]);
      StrCat(@szSQLErrorMsg[0], ' -> ');
      StrCat(@szSQLErrorMsg[0], @SQLNativeMsg[0]);
      StrCat(@szSQLErrorMsg[0], NewLine);
      StrCat(@szSQLErrorMsg[0], @SQLErrorMsg[0]);
      StrCat(@szSQLErrorMsg[0], NewLine);
    end;
  end else begin
    StrPCopy(@SQLErrorState[0], ODBC_LAST_FN_NAME);

    StrCopy(@szSQLErrorMsg[0], '(');
    StrPCopy(@szSQLErrorMsg[1], IntToStr(ODBC_LAST_ERROR_CODE));
    StrCat(@szSQLErrorMsg[0], ')');
    StrCat(@szSQLErrorMsg[0], NewLine);
    StrCat(@szSQLErrorMsg[0], @SQLErrorState[0]);
    StrCat(@szSQLErrorMsg[0], ' is not implemented !');
    StrCat(@szSQLErrorMsg[0], NewLine);
  end;
  If Assigned(EMsg) then begin
   StrLCopy(EMsg, @szSQLErrorMsg[0], ELen);
  end;
  DebugMessageBox(@szSQLErrorMsg[0], 'ODBC ERROR!');
  ODBC_LAST_ERROR_CODE:= 0;
  ODBC_LAST_FN_NAME:= '';
end;

initialization

finalization
  UnloadODBC_DLL;
end.
