{..$DEFINE ORA8}
unit ODBCTest;

interface

{$IFDEF MSWINDOWS}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ODBCDebug, ODBCIntf;
{$ENDIF}
{$IFDEF LINUX}
uses
  Types, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, ODBCDebug, ODBCIntf;
{$ENDIF}

type
  TTestForm = class(TForm)
    ResultMemo: TMemo;
    TesztBitBtn: TBitBtn;
    CloseBitBtn: TBitBtn;
    procedure TesztBitBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure TestODBC;
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.dfm}

{  }
{  Adjust Length of ShortString }
{  }
Function SetShortStrLen(L : integer): integer;
var
  I: integer;
begin
  if L < 0 then
    I:= Abs(L)
  else
    I:= L;
  if I > 255 then
    I:=255;
  Result:= I;
end;
{  }
{  Left }
{  }
Function ShortStrLeft(S: ShortString; N: integer): ShortString;
var
  I: integer;
begin
  I:= SetShortStrLen(N);
  if I < Length(S) then
    Result:= Copy(S, 1, I)
  else
    Result:= S;
end;
{  }
{  Mid }
{  }
Function ShortStrMiddle(S: ShortString; T,N: integer): ShortString;
var
  I,J: integer;
begin
  I:= SetShortStrLen(T);
  J:= SetShortStrLen(N);
  if (I+J-1) <= Length(S) then
    Result:= Copy(S, I, J)
  else
    Result:= ShortStrLeft(S, N);
end;
{  }
{  Right }
{  }
Function ShortStrRight(S : ShortString; N : integer): ShortString;
var
  I: integer;
begin
  I:= SetShortStrLen(N);
  if I < length(S) then
    Result:= Copy(S, length(S)-I+1, I)
  else
    Result:= S;
end;
{  }
{  Space trimmer  }
{  }
Function AllTrimmShort(S:ShortString): ShortString;
var
  I,J,Db: Integer;
begin
  I:=1;
  J:=Length(S);
  while S[I]=' ' do
    Inc(I);
  while S[J]=' ' do
    Dec(J);
  Db:= J-I+1;
  if Db<=0 then
    Result:= ''
  else
    Result:= Copy(S, I, Db);
end;
{  }
{  Filling with a given character }
{  }
Function FillerShort(C: char; N: integer): ShortString;
var
  I: integer;
begin
  Result:= '';
  for I:=1 to SetShortStrLen(N) do
    Result:= Result + C;
end;
{  }
{  Left side filling }
{  }
Function LeftFillerShort(S: ShortString; C: char; N: integer) : ShortString;
var
  I: integer;
begin
  I:= SetShortStrLen(N);
  if I<=Length(S) then
    Result:= S
  else
    Result:= Copy(FillerShort(C, I), 1, I-Length(S)) + S;
end;
{  }
{  Right side filling}
{  }
Function RightFillerShort(S: ShortString; C: char; N: integer): ShortString;
var
  I: integer;
begin
  I:=SetShortStrLen(N);
  if I<=Length(S) then
    Result:= S
  else
    Result:= S + Copy(FillerShort(C, I), 1, I-Length(S));
end;
{  }
{  Center }
{  }
Function CenteredShort(S: ShortString; C: char; N: integer): ShortString;
var
  I,J: integer;
begin
  I:= SetShortStrLen(N);
  If I<=Length(S) then
    Result:= Copy(S, 1, I)
  else begin
    J:= (I-Length(S)) div 2;
    Result:= FillerShort(C, J) + S + FillerShort(C, J);
  end;
end;

procedure TTestForm.TestODBC;
const
{$IFDEF ORA8}
  SQLConnectDSN: PChar = 'TTP2K_ORA';
  SQLConnectUID: PChar = 'ddgaz';
  SQLConnectPWD: PChar = 'ddgaz5';
  ROWSET_SIZE = 10;
{$ELSE}
  SQLConnectDSN: PChar = 'TXTDEMO';
  SQLConnectUID: PChar = 'admin';
  SQLConnectPWD: PChar = '';
{$ENDIF}
  DriverConnect: Boolean = FALSE;

type
  ColInfoType = packed record
    szColName    : array[0..32] of char;
    pcbColName   : smallint;
    pfSqlType    : smallint;
    pcbColDef    : longInt;
    pibScale     : smallint;
    pfNullable   : smallint;
    xpfSqlType   : smallint;
    WorkVariable : pointer;
    pfCType      : smallInt;
    pcbCColDef   : longInt;
  end;

var
  SQL_hENV                     : lpVoid;
  SQL_hDBC                     : lpVoid;
  SQL_hSTMT                    : lpVoid;
  bSQL_IMPLEMENTED_FUNCTIONS   : TSQL_IMPLEMENTED_FUNCTIONS;
  SQLErrorState                : packed array [0..SQL_SQLSTATE_SIZE] of char;
  lSQLReceiveVar               : longInt;
  iSQLReceiveVar               : smallInt;
  SQLErrorCode                 : smallInt;
  SQLColCounts                 : smallInt;
  SQLRowCounts                 : longInt;
//  SQLDriverName                : packed array [0..SQL_MAX_DSN_LENGTH] of char;
//  SQLErrorMsg                  : packed array [0..SQL_MAX_MESSAGE_LENGTH] of char;
//  iSQLErrorMsgLen              : smallInt;
//  iSQLErrorCode                : smallInt;
//  lSQLNativeError              : longInt;
//  sSQLReceiveVar               : packed array [0..SQL_MAX_MESSAGE_LENGTH] of char;
//  wSQLReceiveVar               : word;
//  bSQLReceiveVar               : WordBool;
//  iSQLCounter                  : smallInt;
//
  SelectStmt                   : PChar;
  SelectStmtStr                : packed array [0..2048] of char;
  OneColumn                    : ColInfoType;
  Columns                      : packed array [1..256] of ColInfoType;
  iCol                         : smallint;
  HeaderStr                    : ShortString;
  SeparStr                     : ShortString;
  WorkStr                      : ShortString;
  LineStr                      : ShortString;
  SQLConnectStr                : PChar;
  SQLConnectStrB               : packed array [0..256] of char;
begin
  if LoadODBC_DLL(ODBC_DLL) then begin

    SelectStmt:= @SelectStmtStr[0];
    SQLConnectStr:= @SQLConnectStrB[0];
    StrCopy(SQLConnectStr, 'DSN=');
    StrCat(SQLConnectStr, SQLConnectDSN);
    StrCat(SQLConnectStr, 'UID=');
    StrCat(SQLConnectStr, SQLConnectUID);
    StrCat(SQLConnectStr, 'PWD=');
    StrCat(SQLConnectStr, SQLConnectPWD);
    ResultMemo.Lines.Clear;
    {  }
    {  Connecting to "ODBC32.DLL" or "libodbc.so" master handler }
    {  }
    SQLErrorCode:= SQLAllocEnv(SQL_hENV);
    If SQL_OK(SQLErrorCode, TRUE) then begin
      {  }
      {  Set attributes of HANDLER }
      {  }
      SQLSetEnvAttr(SQL_hENV, SQL_ATTR_ODBC_VERSION, SQL_OV_ODBC3, 0);
      {  }
      {  Allocating a handlerspace for DRIVER }
      {  }
      SQLErrorCode:= SQLAllocConnect(SQL_hENV, SQL_hDBC);
      If SQL_OK(SQLErrorCode, TRUE) then begin
        {  }
        {  Set attributes of DRIVER }
        {  }
        SQLSetConnectAttr(SQL_hDBC, SQL_ATTR_ODBC_CURSORS, SQL_CUR_USE_ODBC, 0);
        {  }
        {  Connecting to "ODTEXT32.DLL" or "libodbctxt.so" DRIVER }
        {  }
        If DriverConnect then begin
          SQLErrorCode:=SQLDriverConnect(SQL_hDBC, Handle, SQLConnectStr, SQL_NTS,
              @SQLErrorState, 0, iSQLReceiveVar, SQL_DRIVER_COMPLETE
          );
        end else begin
          SQLErrorCode:= SQLConnect(SQL_hDBC, SQLConnectDSN, StrLen(SQLConnectDSN),
            SQLConnectUID, SQL_NTS, SQLConnectPWD, SQL_NTS
          );
        end;
        If SQL_OK(SQLErrorCode, FALSE) then begin
          {  }
          {  Which functions are ipmlemented in the driver }
          {  }
          GetSQL_hDBC_Functions(SQL_hDBC, bSQL_IMPLEMENTED_FUNCTIONS);
          {  }
          {  Allocating a workspace of STATEMENTs }
          {  }
          SQLErrorCode:=SQLAllocStmt(SQL_hDBC, SQL_hSTMT);
          If SQL_OK(SQLErrorCode, TRUE) then begin
            {  }
            {  Set attributes of workspace of TABLE }
            {  }
            {SQLErrorCode:= }SQLSetStmtOption(SQL_hSTMT, SQL_CONCURRENCY, SQL_CONCUR_READ_ONLY);
            {$IFDEF ORA8}
              SQLErrorCode:= SQLSetStmtOption(SQL_hSTMT, SQL_CURSOR_TYPE, SQL_CURSOR_DYNAMIC);
              SQLErrorCode:= SQLSetStmtOption(SQL_hSTMT, SQL_ROWSET_SIZE, ROWSET_SIZE);
            {$ENDIF}
            {  }
            {  Close prevesius operates and clear workspace buffers }
            {  }
            {SQLErrorCode:= }SQLFreeStmt(SQL_hSTMT, SQL_CLOSE);
            {  }
            {  SELECT FROM TABLE }
            {  }
            {$IFDEF ORA8}
              StrCopy(SelectStmt,'SELECT Ev, TimeStamp, InfoType, MuID, UserID');
              StrCat(SelectStmt ,' FROM ESMS');
              StrCat(SelectStmt ,' WHERE UserID=35');
            {$ELSE}
              {$IFDEF MSWINDOWS}
                StrCopy(SelectStmt,'SELECT * FROM txtdemo.csv');
                StrCat(SelectStmt ,' WHERE code>0');
              {$ELSE}
                StrCopy(SelectStmt,'SELECT * FROM txtdemo');
                StrCat(SelectStmt ,' WHERE code > "0"');
              {$ENDIF}
            {$ENDIF}
            If NOT bSQL_IMPLEMENTED_FUNCTIONS[Get_SQL_API_FN_Idx(SQL_API_SQLEXECDIRECT)] then begin
               DebugMessageBox('SQLExecDirect is not implemented!', SQLConnectDSN);
              {SQLErrorCode:= }SQLPrepare(SQL_hSTMT, SelectStmt, SQL_NTS);
              SQLErrorCode:= SQLExecute(SQL_hSTMT);
            end else begin
              SQLErrorCode:= SQLExecDirect(SQL_hSTMT, SelectStmt, SQL_NTS);
            end;
            If SQL_OK(SQLErrorCode, TRUE) then begin
              {  }
              {  GET THE RESULTSET OF SELECT }
              {  }
              SQLErrorCode:= SQLRowCount(SQL_hSTMT, SQLRowCounts);
              If SQL_OK(SQLErrorCode, FALSE) then begin
                ResultMemo.Lines.Add('| Rows affected: '+IntToStr(SQLRowCounts)+' |');
              end;
              SQLErrorCode:=SQLNumResultCols(SQL_hSTMT, SQLColCounts);
              If SQL_OK(SQLErrorCode, TRUE) then begin
                HeaderStr:='| '; SeparStr:='|-';
                For iCol:=1 To SQLColCounts do begin
                  with OneColumn do begin
                    {SQLErrorCode:= }SQLDescribeCol(SQL_hSTMT, iCol, @szColName, 32, pcbColName, pfSqlType, pcbColDef, pibScale, pfNullable);
                    If pcbColDef < longInt(pcbColName) then
                      pcbColDef:= longInt(pcbColName);
                    If pcbColDef > 70 then
                      pcbColDef:= 70;
                    if StrComp(@szColName, 'REQUIRED') = 0 then
                      pcbColDef:= 9;
                    Columns[iCol].szColName  := szColName;
                    Columns[iCol].pcbColName := pcbColName;
                    Columns[iCol].pfSqlType  := pfSqlType;
                    Columns[iCol].pcbColDef  := pcbColDef;
                    Columns[iCol].pibScale   := pibScale;
                    Columns[iCol].pfNullable := pfNullable;
                    WorkStr:= Copy(szColName, 0, pcbColName);
                    WorkStr:= RightFillerShort(AllTrimmShort(WorkStr), ' ', pcbColDef);
                  end;
                  HeaderStr:= HeaderStr+WorkStr+'| ';
                  SeparStr:= SeparStr+FillerShort('-',Length(WorkStr));
                  If iCol<>SQLColCounts then
                    SeparStr:= SeparStr+'+-'
                  else
                    SeparStr:= SeparStr+'| ';
                end;
                ResultMemo.Lines.Add(SeparStr);
                ResultMemo.Lines.Add(HeaderStr);
                ResultMemo.Lines.Add(SeparStr);
                {  }
                {  Set Variables }
                {  }
                For iCol:=1 To SQLColCounts do begin
                  with OneColumn do begin
                    szColName  := Columns[iCol].szColName;
                    pcbColName := Columns[iCol].pcbColName;
                    pfSqlType  := Columns[iCol].pfSqlType;
                    pcbColDef  := Columns[iCol].pcbColDef;
                    pibScale   := Columns[iCol].pibScale;
                    pfNullable := Columns[iCol].pfNullable;
                    Case pfSqlType Of
                      SQL_CHAR, SQL_VARCHAR, SQL_LONGVARCHAR, SQL_NUMERIC, SQL_DECIMAL: begin
                        pfCType:= SQL_C_CHAR;
                        pcbCColDef:= pcbColDef+1;
                      end;
                      SQL_INTEGER: begin
                        pfCType:= SQL_C_LONG;
                        pcbCColDef:= SizeOf(longInt);
                      end;
                      SQL_SMALLINT: begin
                        pfCType:= SQL_C_SHORT;
                        pcbCColDef:= SizeOf(smallInt);
                      end;
                      SQL_REAL: begin
                        pfCType:= SQL_C_FLOAT;
                        pcbCColDef:= SizeOf(single);
                      end;
                      SQL_FLOAT, SQL_DOUBLE: begin
                        pfCType:= SQL_C_DOUBLE;
                        pcbCColDef:= SizeOf(double);
                      end;
                      SQL_DATE: begin
                        pfCType:= SQL_C_DATE;
                        pcbCColDef:= SizeOf(tagDATE_STRUCT);
                      end;
                      SQL_TIME: begin
                        pfCType:= SQL_C_TIME;
                        pcbCColDef:= SizeOf(tagTIME_STRUCT);
                      end;
                      SQL_TIMESTAMP: begin
                        pfCType:= SQL_C_TIMESTAMP;
                        pcbCColDef:= SizeOf(tagTIMESTAMP_STRUCT);
                      end;
                      SQL_BINARY, SQL_VARBINARY, SQL_LONGVARBINARY: begin
                        pfCType:= SQL_C_BINARY;
                        pcbCColDef:= pcbColDef+1;
                      end;
                      SQL_BIGINT: begin
                        pfCType:= SQL_C_BINARY;
                        pcbCColDef:= SizeOf(comp);
                      end;
                      SQL_TINYINT: begin
                        pfCType:= SQL_C_TINYINT;
                        pcbCColDef:= SizeOf(shortInt);
                      end;
                      SQL_BIT: begin
                        pfCType:= SQL_C_BIT;
                        pcbCColDef:= pcbColDef+1;
                      end;
                      else begin
                        pfCType:= SQL_C_DEFAULT;
                        pcbCColDef:= pcbColDef+1;
                      end;
                    End;
                    Columns[iCol].pfCType:= pfCType;
                    Columns[iCol].pcbCColDef:= pcbCColDef;
                    GetMem(Columns[iCol].WorkVariable, pcbCColDef);
                    WorkVariable:= Columns[iCol].WorkVariable;
                    {SQLErrorCode:= }SQLBindCol(SQL_hSTMT, iCol, pfCType, WorkVariable^, pcbCColDef, lSQLReceiveVar);
                  end;
                end;
                {  }
                {  First row }
                {  }
                SQLErrorCode:= SQLFetch(SQL_hSTMT);
                While SQL_OK(SQLErrorCode, FALSE) do begin
                  {  }
                  {  Process one row }
                  {  }
                  LineStr:='| ';
                  For iCol:=1 To SQLColCounts do begin
                    with OneColumn do begin
                      szColName   := Columns[iCol].szColName;
                      pcbColName  := Columns[iCol].pcbColName;
                      pfSqlType   := Columns[iCol].pfSqlType;
                      pcbColDef   := Columns[iCol].pcbColDef;
                      pibScale    := Columns[iCol].pibScale;
                      pfNullable  := Columns[iCol].pfNullable;
                      WorkVariable:=Columns[iCol].WorkVariable;
                      pfCType     := Columns[iCol].pfCType;
                      pcbCColDef  := Columns[iCol].pcbCColDef;
                      Case pfCType Of
                        SQL_C_CHAR: begin
                          WorkStr:= PChar(WorkVariable);
                          WorkStr:= RightFillerShort(AllTrimmShort(WorkStr), ' ', pcbColDef);
                        end;
                        SQL_C_LONG: begin
                          Str(longInt(WorkVariable^):pcbColDef, WorkStr);
                        end;
                        SQL_C_SHORT: begin
                          Str(smallInt(WorkVariable^):pcbColDef, WorkStr);
                        end;
                        SQL_C_FLOAT: begin
                          Str(single(WorkVariable^):pcbColDef:pibScale, WorkStr);
                        end;
                        SQL_C_DOUBLE: begin
                          Str(double(WorkVariable^):pcbColDef:pibScale, WorkStr);
                        end;
                        SQL_C_DATE: begin
                          {tagDATE_STRUCT}
                          WorkStr:= '';
                        end;
                        SQL_C_TIME : begin
                          {tagTIME_STRUCT}
                          WorkStr:= '';
                        end;
                        SQL_C_TIMESTAMP: begin
                          {tagTIMESTAMP_STRUCT}
                          WorkStr:= '';
                        end;
                        SQL_C_BINARY: begin
                          If pfSqlType=SQL_BIGINT then begin
                            Str(comp(WorkVariable^):pcbColDef, WorkStr);
                          end else begin
                            {Binary}
                            WorkStr:='BLOB';
                            WorkStr:=RightFillerShort(AllTrimmShort(WorkStr), ' ', pcbColDef);
                          end;
                        end;
                        SQL_C_TINYINT : begin
                          Str(shortInt(WorkVariable^), WorkStr);
                        end;
                        SQL_C_BIT : begin
                          WorkStr:='BLOB';
                          WorkStr:=RightFillerShort(AllTrimmShort(WorkStr), ' ', pcbColDef);
                        end;
                        else begin
                          WorkStr:='BLOB';
                          WorkStr:=RightFillerShort(AllTrimmShort(WorkStr), ' ', pcbColDef);
                        end;
                      End;
                      LineStr:=LineStr+WorkStr+'| ';
                    end;
                  end;
                  ResultMemo.Lines.Add(LineStr);
                  {  }
                  {  Next row }
                  {  }
                  SQLErrorCode:=SQLFetch(SQL_hSTMT);
                end;
                ResultMemo.Lines.Add(SeparStr);
                {  }
                {  Free Variables }
                {  }
                For iCol:=SQLColCounts DownTo 1 do begin
                  FreeMem(Columns[iCol].WorkVariable, Columns[iCol].pcbCColDef);
                end;
              end else begin
                SQLErrorProcess(SQL_hENV, SQL_hDBC, SQL_hSTMT);
              end;
            end else begin
              SQLErrorProcess(SQL_hENV, SQL_hDBC, SQL_hSTMT);
            end;
            {  }
            {  Deallocating the workspace of STATEMENTs }
            {  }
            {SQLErrorCode:= }SQLFreeStmt(SQL_hSTMT, SQL_CLOSE);
            {SQLErrorCode:= }SQLFreeStmt(SQL_hSTMT, SQL_RESET_PARAMS);
            {SQLErrorCode:= }SQLFreeStmt(SQL_hSTMT, SQL_UNBIND);
            {SQLErrorCode:= }SQLFreeStmt(SQL_hSTMT, SQL_DROP);
          end;
          {  }
          {  Disconnect from DRIVER }
          {  }
          {SQLErrorCode:=}SQLDisconnect(SQL_hDBC);
        end else begin
          SQLErrorProcess(SQL_hENV, SQL_hDBC, SQL_NULL_HSTMT);
        end;
        {  }
        {  Deallocating the handlerspace for DRIVER }
        {  }
        {SQLErrorCode:=}SQLFreeConnect(SQL_hDBC);
      end else begin
        SQLErrorProcess(SQL_hENV, SQL_NULL_HDBC, SQL_NULL_HSTMT);
      end;
      {  }
      {  Disconnecting from "ODBC32.DLL" or "libodbc.so" master handler }
      {  }
      {SQLErrorCode:=}SQLFreeEnv(SQL_hENV);
    end;

    UnloadODBC_DLL;
  end;
end;

procedure TTestForm.TesztBitBtnClick(Sender: TObject);
begin
  TestODBC;
end;

end.
